/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\FRMREVIEW.C
 Author:        Richard KIELBASA  (adaptateur)
 Project:       Echecs
 State:         Termin
 Creation Date: 7 12 2003
 Description:   See at the end of file

------------------------------------------------------------------------*/


#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>

#include "gnuchess.h"
#include "display.h"
#include "mainechecs.h"
#include "Echecs_rc.h"

/*procdures prives------------------------------------------------------*/
static BOOL  CALLBACK gererFrmRevoirJeu( HWND hDlg, unsigned message,WPARAM wParam, LPARAM lParam);

/*------------------------------------------------------------------------
Procedure:     appelRevoirJeu ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int appelRevoirJeu ( HWND hWnd, HANDLE hInst)
{
	int status;

	status = DialogBoxParam (hInst, MAKEINTRESOURCE(DLG_REVIEW),  hWnd, (DLGPROC) gererFrmRevoirJeu, 0);

	return status;
}

/*------------------------------------------------------------------------
Procedure:     ReviewDlgProc ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL  CALLBACK gererFrmRevoirJeu( HWND hDlg, unsigned message, WPARAM wParam, LPARAM lParam)
{

	int i,f,t;
	char tmp[50];

	switch (message)
	{
	case WM_INITDIALOG:		   /* message: initialize dialog box */

		for (i = 1; i <= GameCnt; i++)
			{
			f = GameList[i].gmove >> 8;
			t = (GameList[i].gmove & 0xFF);
			makeMoveString (f, t, false);
			sprintf (tmp, "%4d-%c\t%5s\t%-5d\t%-2d\t%-5d",
				(i+1)/2, (i%2 ? 'w' : 'b'),
				//(char *)mvstr[0],
				Display_moveString,
				GameList[i].score, GameList[i].depth,				GameList[i].time);

			SendDlgItemMessage (hDlg, LSB_REVIEW, LB_ADDSTRING, 0, (LPARAM) tmp);
		}
		SendDlgItemMessage (hDlg, LSB_REVIEW, WM_SETREDRAW, TRUE, 0);
		return (TRUE);


	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case CMD_REVIEW_QUIT:
			EndDialog(hDlg, 0);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;


	}

	return (FALSE);			      /* Didn't process a message    */
}

/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/
