/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\FRMTIMECTRL.C
 Author:        Richard KIELBASA  (adaptateur)
 Project:       Echecs
 State:         Termin
 Creation Date: 7 12 2003
 Description:   See at the end of file

------------------------------------------------------------------------*/


#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>
#include "gnuchess.h"
#include "mainechecs.h"
#include "Echecs_rc.h"

//extern int TCmoves, TCminutes, TCflag;

/*procdures prives----------------------------------------------------*/
static BOOL  CALLBACK gererFrmTimeControl ( HWND hDlg, unsigned message, WPARAM wParam, LPARAM lParam);

static int tmpTCmoves;
static int tmpTCminutes;

/*------------------------------------------------------------------------
Procedure:     appelTimeControl ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int appelTimeControl ( HWND hWnd, HANDLE hInst, DWORD Param )
{

	int status;

	status = DialogBoxParam (hInst, MAKEINTRESOURCE(DLG_TIMECONTROL),hWnd,(DLGPROC) gererFrmTimeControl, Param);
	return status;
}


/*------------------------------------------------------------------------
Procedure:     gererFrmTimeControl ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL  CALLBACK gererFrmTimeControl ( HWND hDlg, unsigned message,WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_INITDIALOG:		   /* message: initialize dialog box */
		{
			int select;

			if(TCmoves == 1) select = TMDLG_1MOV;
			else if(TCmoves == 10) select = TMDLG_10MOV;
			else if(TCmoves == 20) select = TMDLG_20MOV;
			else if(TCmoves == 40) select = TMDLG_40MOV;
			else if(TCmoves == 60) select = TMDLG_60MOV;
			else
			    {
				TCmoves = 1;
				select = TMDLG_1MOV;
			}

			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, select);
			tmpTCmoves   = TCmoves;

			if (TCminutes ==  5) select = TMDLG_5MIN;
			else if (TCminutes ==  15) select = TMDLG_15MIN;
			else if (TCminutes ==  30) select = TMDLG_30MIN;
			else if (TCminutes ==  60) select = TMDLG_60MIN;
			else if (TCminutes ==  600) select = TMDLG_600MIN;
			else
			    {
				TCminutes = 5;
				select = TMDLG_5MIN;
			}

			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, select);
			tmpTCminutes = TCminutes;

		}
		return (TRUE);
		/*
		case WM_SYSCOMMAND:
		if ( (wParam&0xfff0) == SC_CLOSE )
		{
		EndDialog(hDlg, 0);
		return TRUE;
		}
		break;
		*/

	case WM_COMMAND:		      /* message: received a command */
		switch (LOWORD(wParam))
		{

		case CMD_TIMECTRL_OK:
			TCminutes = tmpTCminutes;
			TCmoves   = tmpTCmoves;
			EndDialog(hDlg, 1);
			return TRUE;
			break;

		case CMD_TIMECTRL_CANCEL:
			EndDialog(hDlg, 0);
			return TRUE;
			break;

		case TMDLG_1MOV:
			tmpTCmoves = 1;
			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, TMDLG_1MOV);
			break;
		case TMDLG_10MOV:
			tmpTCmoves = 10;
			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, TMDLG_10MOV);
			break;
		case TMDLG_20MOV:
			tmpTCmoves = 20;
			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, TMDLG_20MOV);
			break;
		case TMDLG_40MOV:
			tmpTCmoves = 40;
			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV,  TMDLG_40MOV);
			break;
		case TMDLG_60MOV:
			tmpTCmoves = 60;
			CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, TMDLG_60MOV);
			break;
			//	tmpTCmoves = wParam - TMDLG_MOV;
			//	CheckRadioButton ( hDlg, TMDLG_1MOV, TMDLG_60MOV, wParam);


		case TMDLG_5MIN:
			tmpTCminutes = 5;
			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, TMDLG_5MIN );
			break;
		case TMDLG_15MIN:
			tmpTCminutes = 15;
			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, TMDLG_15MIN );
			break;
		case TMDLG_30MIN:
			tmpTCminutes = 30;
			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, TMDLG_30MIN );
			break;
		case TMDLG_60MIN:
			tmpTCminutes = 60;
			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, TMDLG_60MIN );
			break;
		case TMDLG_600MIN:
			tmpTCminutes = 600;
			CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, TMDLG_600MIN );
			break;
			//tmpTCminutes = wParam - TMDLG_MIN;
			//CheckRadioButton ( hDlg, TMDLG_5MIN, TMDLG_600MIN, wParam);
			//break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		return TRUE;

	}

	return (FALSE);			      /* Didn't process a message    */
}

/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/
