/*------------------------------------------------------------------------
Module:        C:\Maison\CodeC\Echecs\MAINECHECS.C
Author:        Richard KIELBASA (adaptateur)
Project:       Echecs
State:         En cours
Creation Date: 6 12 2003
Description:   See at the end of file
------------------------------------------------------------------------*/

#define NOATOM                /*Minimize windows.h processing*/
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOCOMM
#define NOKANJI

#include <windows.h>		  /* required for all Windows applications */
#include <windowsx.h>
#include <string.h>
#include <time.h>
#include <shlobj.h>

#include "gnuchess.h"
#include "Echecs_rc.h"
#include "mainechecs.h"
#include "frmStats.h"
#include "initiali.h"
#include "display.h"
#include "search.h"
#include "book.h"
#include "board.h"
#include "piece.h"
#include "clsImageList.h"
#include "frmcolor.h"
#include "iofiles.h"
#include "clsversion.h"
#include "specialres.h"
//#include "debog.h"
/*-------------------------------frmXXX.c--------------------------*/
extern int appelAPropos  (HWND hwnd);
extern int appelInputNumber (HANDLE hInst, HWND hWnd, char * szPrompt, int def);
extern int appelParaAlgo (HINSTANCE hInst, HWND hwndParent, int* pta, int*ptb, int* ptc);
extern HWND appelStatistiques ( HWND hWnd, HANDLE hInst, RECT * pt);
extern int appelPromote  (HWND hWnd, HANDLE hInst);
extern int appelRevoirJeu (HWND hWnd, HANDLE hInst);
extern int appelTimeControl (HWND hWnd, HANDLE hInst, DWORD Param );
extern int appelTest   (HWND hWnd, HANDLE hInst);
extern int appelExamine(HWND hwndParent, char *nomFichier);
extern char *Version;

/*varibles publiques---------------------------------------------*/
HINSTANCE hInst;              /* current instance */
char szAppName[] = "Echecs";

/*variables prives----------------------------------------------*/
/*identificateurs de controles ou idem*/
#define STB_MAIN		8002 /*barre d'tat*/
#define BASEAFFICHE     8100 /*controle sur feuille*:

/*pour les validations de menu, n'a rien  voir avec une tiquette*/
#define MENU_ID_FILE      0
#define MENU_ID_EDIT      1
#define MENU_ID_SKILL     2
#define MENU_ID_TOOLS     3
#define MENU_ID_APP       4
#define MENU_ID_SIDE      5
/*inutile*/
#define MENU_ID_ABORT     7

/*Messages utilisateurs  part entire*/
#define MSG_EDITBOARD      (WM_USER+1)
#define MSG_USER_MOVE      (WM_USER+2)
#define MSG_USER_ENTERED_MOVE (WM_USER+3)
#define MSG_COMPUTER_MOVE  (WM_USER+4)
#define MSG_CHESS_ABORT    (WM_USER+5)

static HWND hMain;
static HWND hStatusBar;				//StatusBar
static BOOL coords = TRUE;
static HBRUSH hBrushBackGround = NULL;
static HFONT hPolice = NULL;
static HMENU hMainMenu;

static int FirstSq = -1;         /* Flag is a square is selected */
static BOOL GotFirst = FALSE;
static BOOL EditActive = FALSE;   /* Edit mode? */
static BOOL UserMove = TRUE;     /* User or computer's turn */

/*procdures prives---------------------------------------------*/
static BOOL runUnique(char *nom);
static HWND creerBarreEtat(HWND hWnd, HINSTANCE hInst);
static int moulinerMessagesA(HACCEL hAccelTable);
static LRESULT CALLBACK gererMainEchecs( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static BOOL initApplication(HINSTANCE);
static void activerMenus (HWND hWnd, WORD wParam, LONG lParam );
static void gererMenu(HWND, int id, HWND hCtrl, UINT iNotify);
static BOOL afficherDirect(HDC hDC);
static HFONT creerPolice(int taille, char*nomPolice);
static BOOL creerAffichage(HWND hParent);
static BOOL disposerAffichage(HWND hParent);

/*------------------------------------------------------------------------
Procedure:     WinMain ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int WINAPI WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine,	int nCmdShow)
{
	HWND hWnd;
	HANDLE hAccelTable;
	int irep;

	hInst = hInstance;			/* Saves the current instance	     */
	/*only single run*/
	if(!runUnique(szAppName))
	{
		char chaine[MAXCHAINE];

		LoadString(hInst, ITT_ISRUNNING, chaine, MAXCHAINE);
		MessageBox(NULL, chaine, szAppName, MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
		return 0;
	}

	if (!initApplication(hInstance))
	{
		char chaine[MAXCHAINE];

		LoadString(hInst, ITT_NORUN, chaine, MAXCHAINE);
		MessageBox(NULL, chaine, szAppName ,MB_OK|MB_ICONSTOP|MB_SYSTEMMODAL);
		return 0;
	}

	/*initialiser la version*/
	VER_initialiser (Version);
	/*charger les icones*/
	Images_createListIcon(hInst);

	hAccelTable = LoadAccelerators(hInst, MAKEINTRESOURCE(ACC_MENU));

	/* Create the main window.  It will be autosized in WM_CREATE message */
	hWnd = CreateWindow(szAppName,	szAppName, WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN|WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT ,
		CW_USEDEFAULT, CW_USEDEFAULT,
		NULL,	NULL,	hInstance,	NULL);

	if (!hWnd)	return (0);
	hMain = hWnd ;//js

#ifdef DEBOG
	OuvrirConsole();
#endif
	/* Initialize chess */
	if (Initialize_main ( hWnd ) != 0)
	{
		ShowMessage (hWnd, ITT_INITERROR);
		Initialize_freeGlobals ();
		return (0);
	}

	/*rajout par RK pour initialiser proprement l'affichage*/
	player = computer;
	UpdateClocks ();
	if (flag.post)
		Stats_ShowNodeCnt (NodeCnt, Display_evrate);

	UpdateWindow(hWnd);				  /* Sends WM_PAINT message  */

	/*retour  version antrieure*/
	player = opponent;
	ShowSidetoMove (hWnd);

	/*boucle */
	irep = moulinerMessagesA(hAccelTable);
	if(irep == -1)
	{
		char chaine[MAXCHAINE];

		LoadString(hInst, ITT_MILLERR, chaine, MAXCHAINE);
		MessageBox(hWnd, chaine, szAppName, MB_ICONSTOP);
	}

	return irep;	   /* Returns the value from PostQuitMessage or -1*/
}

/*------------------------------------------------------------------------
Procedure:     gererMainEchecs ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static LRESULT CALLBACK gererMainEchecs( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_CREATE:
		{
			RECT rc;
			/*valeurs par dfaut en cas de registre defaillant*/
			TCminutes = 5; 	//Standardspielzeit
			GetClientRect( hWnd, &rc);

			/*chargement des paramtres  partir du registre*/
			Color_getFromReg(szAppName); //Registryeintrge holen
			Board_getFromReg (szAppName);
			Display_getFromReg (szAppName , &rc);

			/*Size main window */
			SetWindowPos(hWnd,NULL,
				rc.left, rc.top,
				rc.right - rc.left, rc.bottom - rc.top,
				SWP_NOZORDER);
			Board_setOrigine(rc.right/2, rc.bottom/2);

			hBrushBackGround = CreateSolidBrush ( clrBackGround );
			//hBrushBackGround = CreatePatternBrush ( clrBackGround );
			/* 1 = pawn, 2 = knight, 3 = bishop, 4 = rook, 5 = queen, 6 = king*/
			Images_loadBmpPieces(hInst);
			Images_setPieceColor();

			creerBarreEtat(hWnd, hInst);//Statusleiste
			creerAffichage(hWnd);

			/*sert  initialiser le texte du menu statusbarre*/
			Display_StatBarOn = !Display_StatBarOn;
			SendMessage(hWnd, WM_COMMAND, IDM_SBON, 0);
			/* initialiser aprs la dfinition de l'chiquier*/
		}
		break;

	case WM_SIZE:
		Board_setOrigine(LOWORD(lParam)/2, HIWORD(lParam)/2);
		disposerAffichage(hWnd);
		SendMessage(hStatusBar, WM_SIZE, wParam, lParam);
		break;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hDC;

			if ( FirstSq != -1 )
			{        /*Properly repaint hilighted square*/
				POINT pt;
				POINT ptsz;
				RECT rect;

				Board_querySqOrigin ( FirstSq%8, FirstSq/8, &pt);
				Board_querySqSize0 ( &ptsz );
				rect.left = pt.x;
				rect.right= pt.x +  ptsz.x ;
				rect.top  = pt.y -  ptsz.x ;
				rect.bottom = pt.y;
				InvalidateRect (hWnd, &rect, FALSE);
			}

			hDC = BeginPaint ( hWnd, &ps);

			Board_draw ( hDC, flag.reverse, clrBlackSquare, clrWhiteSquare );
			if ( coords ) Board_drawCoords ( hDC, flag.reverse, clrBackGround, clrText);
			Pieces_drawAll ( hDC, flag.reverse, Display_board, Display_color, clrBlackPiece, clrWhitePiece );
			Board_drawLight( hDC, flag.reverse, player == black);

			EndPaint ( hWnd, &ps);

			if ( FirstSq != -1 ) Board_hiliteSquare ( hWnd, FirstSq);
		}
		break;

	case WM_CTLCOLORSTATIC:     /*Enable setting colors for the message controls Get*/
		{
			SetBkColor ((HDC) wParam, clrBackGround);
			SetBkMode ((HDC) wParam, TRANSPARENT);
			SetTextColor ((HDC) wParam, clrText);

			return (DWORD) hBrushBackGround;
			//return (DWORD) GetStockObject(WHITE_BRUSH);
		}

	case WM_ERASEBKGND:
		{
			RECT rect;

			GetClientRect ( hWnd, &rect);
			FillRect ( (HDC)wParam, &rect, hBrushBackGround);
		}
		return TRUE;

	case WM_INITMENUPOPUP:
		if ( UserMove )
		{            /*Abort thinklook ahead*/
			flag.timeout = true;
			flag.bothsides = false;
		}
		if ( !EditActive ) activerMenus (hWnd, wParam, lParam);
		break;

	case WM_LBUTTONDOWN:
		{
			POINTS point;

			/* If computer is thinking on human's time stop it at the first
			button click.  add test to ensure that "human" can't interupt
			the computer from thinking through its turn */
			if ( UserMove )
			{
				flag.timeout = true;
				flag.bothsides = false;
			}

			/* Don't continue unless reason to */
			if ( !(EditActive || UserMove)) break;

			point = MAKEPOINTS (lParam );
			{
				int Hit;

				Hit = Board_getSquare (point.x, point.y );

				if ( Hit == -1 )
				{
					if ( FirstSq != -1)
					{
						Board_unHiliteSquare ( hWnd, FirstSq);
						GotFirst = FALSE;
						FirstSq = -1;
					}
					break;
				}

				if ( GotFirst )
				{
					Board_unHiliteSquare( hWnd, FirstSq);
					GotFirst = FALSE;

					if (EditActive)
					{
						PostMessage ( hWnd, MSG_EDITBOARD,((FirstSq<<8)|Hit), (LONG) NULL);
					}
					else if (UserMove)
					{
						PostMessage ( hWnd, MSG_USER_ENTERED_MOVE, ((FirstSq<<8)|Hit), (LPARAM) NULL);
					}
					FirstSq = -1;
				}
				else {
					GotFirst = TRUE;
					FirstSq = Hit;
					Board_hiliteSquare ( hWnd, Hit);
				}
			}
		}
		break;

	case MSG_EDITBOARD:
		{
			int Square, First;

			if ( flag.reverse )
			{
				First = 63 - ((wParam>>8) & 0xff);
				Square  = 63 - (wParam & 0xff);
			}
			else {
				First = (wParam>>8) & 0xff;
				Square  = wParam & 0xff;
			}

			board[Square] = board[First];
			color[Square] = color[First];

			board[First] = no_piece;
			color[First] = neutral;

			UpdateDisplay (hWnd, First, Square, false, false);
		}
		break;

	case MSG_USER_MOVE:
		if ( flag.bothsides && !flag.mate )
		{
			SelectMove ( hWnd, opponent, 1);
			if ( flag.beep ) MessageBeep (0);
			PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM)NULL);
		}
		else if (!flag.mate)
		{
			UserMove = TRUE;

			ft = 0;
			player = opponent;
			ShowSidetoMove (hWnd);
			ShowGameCount (hWnd);
			{
				/* Set up to allow computer to think while user takes move*/
				int tmp;
				unsigned int mv;
				char string[10];


				if ( hint>0 && !flag.easy && Book == NULL)
				{
					time0 = time ( NULL);
					makeMoveString ( hint>>8, hint&0xff, false);
					tmp = epsquare;
					/*?*/
					//strcpy ( string, mvstr[0]);
					strcpy ( string, Display_moveString);
					if ( VerifyMove (hWnd, string, 1, &mv) )
					{
						SelectMove ( hWnd, computer, 2);
						//VerifyMove ( hWnd, mvstr[0], 2, &mv);
						VerifyMove ( hWnd, Display_moveString, 2, &mv);
						if ( Sdepth>0 ) Sdepth --;
					}
					ft = time (NULL) - time0;
					epsquare = tmp;
				}
			}
		}
		break;

	case MSG_USER_ENTERED_MOVE:
		{
			int temp;
			unsigned int mv;
			int Square,First;
			char str[10];
			int algbr_flag;


			UserMove = FALSE;
			player = opponent;
			/* Fix coord's if user "reversed" board */
			if ( flag.reverse )
			{
				First = 63 - ((wParam>>8) & 0xff);
				Square  = 63 - (wParam & 0xff);
			}
			else
			    {
				First = (wParam>>8) & 0xff;
				Square  = wParam & 0xff;
			}

			/* Logic to allow selection for pawn promotion */
			if ( (board[First] == pawn) &&( (Square <8) || (Square>55)) )
			{
				algbr_flag = promote + appelPromote (hWnd, hInst);
			}
			else algbr_flag = 0;
			makeMoveString ( First, Square, algbr_flag);
			/*?*/
			//strcpy ( str, mvstr[0] );
			strcpy ( str, Display_moveString );

			temp = VerifyMove ( hWnd, str, 0, &mv);
			if ( temp && (mv != hint))
			{
				Sdepth = 0;
				ft = 0;
				ElapsedTime (1);
				PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM)NULL);
			}
			else if ( temp == TRUE)
			{
				ElapsedTime (1);
				PostMessage ( hWnd, MSG_COMPUTER_MOVE,0, (LPARAM)NULL);
			}
			else PostMessage ( hWnd, MSG_USER_MOVE, 0, (LPARAM)NULL);
		}
		break;

	case MSG_COMPUTER_MOVE:
		{
			//HCURSOR hCursorOld;
			//hCursorOld = SetCursor ( LoadCursor(NULL, IDC_WAIT) );

			//ShowCursor (TRUE);
			if ( !(flag.quit || flag.mate || flag.force) )
			{
				SelectMove ( hWnd, computer, 1);
				if ( flag.beep ) MessageBeep (0);
			}

			//SetCursor ( hCursorOld);

			PostMessage ( hWnd, MSG_USER_MOVE,0, (LPARAM)NULL);
		}
		break;

		/* Menu item processing */
	case WM_COMMAND:
		HANDLE_WM_COMMAND(hWnd, wParam, lParam, gererMenu)	;
		break;

	case WM_SYSCOMMAND:
		if( (wParam & 0xFFF0) == SC_CLOSE)
		{/*obligatoire afin d'viter le plantage pendant que l'ordinateur travaille*/
			flag.quit = TRUE;
			flag.timeout = true;
			flag.bothsides = false;
			PostMessage ( hWnd, WM_CLOSE, 0, 0);
		}
		else
		    return DefWindowProc(hWnd, message, wParam, lParam);
		break;

	case WM_CLOSE:
		{
			char chaine[MAXCHAINE];
			int irep;

			if ( GameCnt == 0 )
			{
				DestroyWindow ( hWnd);
				break;
			}
			LoadString(hInst, ITT_QUIT, chaine, MAXCHAINE);
			irep = MessageBox(hWnd, chaine, szAppName, MB_YESNOCANCEL|MB_ICONQUESTION|MB_SYSTEMMODAL|MB_DEFBUTTON2	);
			if(irep == IDYES)
			{
				SendMessage (hWnd, WM_COMMAND, ITM_CHESS_SAVE, 0);
				DestroyWindow ( hWnd);
			}
			else if (irep == IDNO)
				DestroyWindow ( hWnd);

		}
		break;
	case WM_DESTROY:		  /* message: window being destroyed */
		{
			RECT rc;
			DeleteObject (hBrushBackGround);
			DeleteObject (hPolice);
			Board_delHit ();
			Color_saveInReg(szAppName);
			Board_saveInReg (szAppName);
			GetWindowRect(hWnd, &rc);
			Display_saveInReg (szAppName, &rc);
			Book_Free();
			Images_freeAll();
			Initialize_freeGlobals ();
			PostQuitMessage(0);
		}
		break;

	default:
		return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	return (0);
}

/*------------------------------------------------------------------------
Procedure:     gererMenu ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void gererMenu(HWND hWnd, int id, HWND hCtrl, UINT iNotify)
{

	HMENU hMenu;

	hMenu = GetMenu(hWnd);
	switch (id)
	{
		/*Fichier*/
	case ITM_CHESS_NEW:
		Initialize_newGame(hWnd);
		Book_Free();
		/*chargement des ouvertures*/
		Book_getOpenings ( hWnd);
		break;

	case ITM_CHESS_SAVE:
		{
			char FileName[MAX_PATH];
			char chaine[MAXCHAINE];
			BOOL btest;

			LoadString(hInst, ITT_SAVE, chaine, MAXCHAINE);
			btest = Iofiles_getDlgSaveOpen(hWnd, chaine, "chs", szAppName, FileName, MAX_PATH, FILESAVE);
			if (btest)
			{
				SaveGame ( hWnd, FileName);
				LoadString(hInst, ITT_SAVESUCCESS, chaine, MAXCHAINE);
				DisplayInfo( HCOMPUTERMOVE, chaine);
				MessageBeep (MB_ICONINFORMATION);
			}
			else
			    {
				ShowMessage(hWnd, ITT_SAUVEPARTIE);
			}
		}
		break;

	case ITM_CHESS_GET:
		{
			char FileName[MAX_PATH];
			char chaine[MAXCHAINE];
			BOOL btest;

			LoadString(hInst, ITT_LOAD, chaine, MAXCHAINE);
			btest = Iofiles_getDlgSaveOpen(hWnd, chaine, "chs", szAppName, FileName, MAX_PATH, FILEOPEN);
			if (btest)
			{
				GetGame ( hWnd, FileName );
				LoadString(hInst, ITT_LOADSUCCESS, chaine, MAXCHAINE);
				DisplayInfo( HCOMPUTERMOVE, chaine);
				MessageBeep (MB_ICONINFORMATION);
			}
			else
			    {
				ShowMessage(hWnd, ITT_CHARGEPARTIE);
			}
		}
		break;
		/*lister le jeu en langage 'checs'*/
	case ITM_CHESS_LIST:
		{
			char chaine[MAXCHAINE];
			char FileName[MAX_PATH];
			BOOL btest;

			LoadString(hInst, ITT_ARCHIVER, chaine, MAXCHAINE);
			btest = Iofiles_getDlgSaveOpen(hWnd,chaine, "lst", szAppName, FileName, MAX_PATH, FILESAVE);
			if(btest)
				Iofiles_listGame ( hWnd, FileName );
		}
		break;
	case ITM_CHESS_CONS:
		{
			char chaine[MAXCHAINE];
			char FileName[MAX_PATH];
			BOOL btest;

			LoadString(hInst, ITT_CONSULTER, chaine, MAXCHAINE);
			btest = Iofiles_getDlgSaveOpen(hWnd, chaine, "lst", szAppName, FileName, MAX_PATH, FILEOPEN);
			if(btest)
				appelExamine(hWnd, FileName);
		}
		break;
		/*quitter le logiciel*/
	case ITM_CHESS_QUIT:
		flag.quit = TRUE; /*revoir*/
		flag.timeout = true;
		flag.bothsides = false;
		PostMessage ( hWnd, WM_CLOSE, 0, 0);
		break;
		/**/

	case ITM_CHESS_EDIT:
		{
			char chaine[MAXCHAINE];

			EditActive = TRUE;
			hMenu = CreateMenu ();
			LoadString(hInst, ITT_EDITDONE, chaine, MAXCHAINE);
			AppendMenu ( hMenu, MF_STRING, ITM_CHESS_EDITDONE, chaine);
			hMainMenu = GetMenu ( hWnd);
			SetMenu ( hWnd, hMenu);
			DrawMenuBar ( hWnd);
		}
		break;

	case ITM_CHESS_EDITDONE:
		EditActive = FALSE;
		hMenu = GetMenu ( hWnd );
		SetMenu ( hWnd, hMainMenu );
		DrawMenuBar ( hWnd );
		DestroyMenu ( hMenu );
		GameCnt = 0;
		Game50 = 1;
		ZeroRPT ();
		Sdepth = 0;
		InitializeStats ();
		PostMessage ( hWnd, MSG_USER_MOVE, 0, (LPARAM)NULL);
		break;

	case ITM_CHESS_REVIEW:
		appelRevoirJeu ( hWnd, hInst );
		break;

	case ITM_CHESS_TEST:
		appelTest (hWnd, hInst);
		break;

	case ITM_CHESS_HASH:
		flag.hash = !flag.hash;
		break;

	case ITM_CHESS_BEEP:
		flag.beep = !flag.beep;
		break;

	case ITM_CHESS_COORD:
		coords = !coords;
		UpdateDisplay(hWnd,0,0,1,0);
		break;

	case ITM_CHESS_BOTH:
		flag.bothsides = !flag.bothsides;
		flag.easy = true;
		Sdepth = 0;
		PostMessage ( hWnd, MSG_USER_MOVE, 0, (LPARAM)NULL);
		break;

	case ITM_CHESS_BOOK:
		if ( Book != NULL )
		{
			Book_Free ();
			Book = NULL;
		}
		break;
		/*Statistiques*/
	case ITM_CHESS_POST:
		if ( flag.post )
		{
			Stats_destroy();
			flag.post = false;
		}
		else
		{
			RECT rc;

			GetWindowRect(hWnd, &rc);
			appelStatistiques ( hWnd, hInst, &rc);
			flag.post = TRUE;
		}
		break;

	case ITM_CHESS_ALGO:
		{
			appelParaAlgo(hInst, hWnd, &Awindow, &Bwindow, &contempt);
			break;
		}
	case ITM_CHESS_UNDO:
		if ( GameCnt > 0 ) Undo(hWnd);
		break;

	case ITM_CHESS_REMOVE:
		if ( GameCnt > 1)
		{
			Undo(hWnd);
			Undo (hWnd);
		}
		break;

	case ITM_CHESS_FORCE:
		computer = opponent;
		opponent = otherside[computer];
		ShowPlayers ();
		PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM) NULL);
		break;

	case ITM_CHESS_RANDOM:/*bistable*/
		if ( dither == 0 ) dither = 6;
		else dither = 0;
		break;

	case ITM_CHESS_EASY:
		flag.easy = !flag.easy;
		break;

	case ITM_CHESS_DEPTH:
		{
			char chaine[128];

			LoadString(hInst, ITT_MAXSEARCH, chaine, 128);
			MaxSearchDepth = appelInputNumber ( hInst, hWnd, chaine, MaxSearchDepth);
			break;
		}
	case ITM_CHESS_REVERSE:
		flag.reverse = !flag.reverse;
		ShowPlayers ();
		UpdateDisplay(hWnd,0,0,1,0);
		break;

	case ITM_PETITECHIQ:
		Board_setSize( 1);
		disposerAffichage(hWnd);
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case ITM_NORMALECHIQ:
		Board_setSize( 2);
		disposerAffichage(hWnd);
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case ITM_GRANDECHIQ:
		Board_setSize( 3);
		disposerAffichage(hWnd);
		InvalidateRect(hWnd, NULL, TRUE);
		break;

	case ITM_CHESS_SWITCH:
		computer = otherside[computer];
		opponent = otherside[opponent];
		flag.force = false;
		Sdepth = 0;
		ShowPlayers ();
		PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM)NULL);
		break;

	case ITM_CHESS_BLACK:
		computer = black;
		opponent = white;
		flag.force = false;
		Sdepth = 0;
		ShowPlayers ();
		PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM)NULL);
		break;

	case ITM_CHESS_WHITE:
		computer = white;
		opponent = black;
		flag.force = false;
		Sdepth = 0;
		ShowPlayers ();
		PostMessage ( hWnd, MSG_COMPUTER_MOVE, 0, (LPARAM)NULL);
		break;

		/*apparence*/
	case ITM_COLOR:
		appelColor( hInst, hWnd);

		DeleteObject (hBrushBackGround);
		hBrushBackGround = CreateSolidBrush ( clrBackGround );
		InvalidateRect (hWnd, NULL, TRUE);
		UpdateWindow(hWnd);
		break;

	case IDM_DEFAULT:
		Color_setStandard ();
		Images_setPieceColor();
		DeleteObject (hBrushBackGround);
		hBrushBackGround = CreateSolidBrush ( clrBackGround );
		InvalidateRect (hWnd, NULL, TRUE);
		break;
		/*StatusBar bistable*/
	case IDM_SBON:
		{
			char chaine[MAXCHAINE];
			int isw, ittsb;

			if (Display_StatBarOn)
			{
				Display_StatBarOn = FALSE;
				isw = SW_HIDE;
				ittsb = ITT_SB;
			}
			else
			    {
				Display_StatBarOn = TRUE;
				isw = SW_SHOW;
				ittsb = ITT_NOSB;
			}
			ShowWindow(hStatusBar, isw);
			LoadString(hInst, ittsb, chaine, MAXCHAINE);
			ModifyMenu(hMenu, IDM_SBON, MF_BYCOMMAND,  IDM_SBON, chaine);
		}

		break;
	case IDM_TIMECONTROL:
		if ( appelTimeControl (hWnd, hInst, id) )
		{
			TCflag = (TCmoves > 1);
			if (TCflag)
			{
				/*rien dans l'original*/
			}
			SetTimeControl ();
		}
		break;
		/*aide*/
	case ITM_CHESS_HINT:
		GiveHint (hWnd);
		break;

	case ITM_LICENSE:
		appelExamine(hWnd, "copying.txt");
		break;

	case ITM_README:
		appelExamine(hWnd, "readme.txt");
		break;

	case ITM_CHESS_ABOUT:
		appelAPropos(hWnd);
		break;
	}

	return ;
};

/*------------------------------------------------------------------------
Procedure:     creerBarreEtat ID:1
Purpose:       Cration de la barre d'tat
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static HWND creerBarreEtat(HWND hWnd, HINSTANCE hInst)
{
#define NBCASES 6
	UINT sb_size[NBCASES] ;
	/*attention  la rpartition implicite

	*	 HCOMPUTERCOLOR 0
	*	 HWHOSTURN      1
	*	 HCLOCKCOMPUTER 2
	*	 HCLOCKHUMAN    3
	*	 HCOMPUTERMOVE  4
	*	 HGAMECNT  		5
	*/

	hStatusBar = CreateWindowEx(0, STATUSCLASSNAME, NULL,WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP | CCS_BOTTOM ,
		0, 0, 0, 0,hWnd, (HMENU)STB_MAIN, hInst, NULL);


	sb_size[0] =              150;
	sb_size[1] = sb_size[0] + 150;
	sb_size[2] = sb_size[1] + 100;
	sb_size[3] = sb_size[2] + 100;
	sb_size[4] = sb_size[3] + 100;
	sb_size[5] = -1;//sb_size[3] + 100;

	SendMessage(hStatusBar, SB_SETPARTS, (WPARAM)NBCASES, (LPARAM)(LPINT)sb_size);


	return hStatusBar;
}


/*------------------------------------------------------------------------
Procedure:     initApplication ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL initApplication(HINSTANCE hInst)
{
	/*
	* declaration des variables locales
	* =================================
	*/
	WNDCLASSEX wcx;
	INITCOMMONCONTROLSEX iccex;

	/*
	* code executable
	* ===============
	*/
	memset(&wcx, 0, sizeof(WNDCLASSEX));

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.hInstance	= hInst;
	wcx.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
	wcx.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcx.hIcon		= LoadIcon(hInst, MAKEINTRESOURCE(ICO_CHESS));
	wcx.hIconSm = NULL;

	/*feuille principale*/
	wcx.style		= CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wcx.lpfnWndProc	= (WNDPROC) gererMainEchecs;
	wcx.lpszClassName	= szAppName;
	wcx.lpszMenuName	= MAKEINTRESOURCE(MNU_CHESS);

	if (!RegisterClassEx(&wcx))	return FALSE;

	/*feuilles de dialogue*/
	wcx.style		= 0;
	wcx.lpfnWndProc = DefDlgProc;
	wcx.cbWndExtra = DLGWINDOWEXTRA;
	wcx.lpszClassName = "dialog";
	wcx.lpszMenuName = NULL;

	if (!RegisterClassEx(&wcx))	return FALSE;

	/*common controls*/
	iccex.dwICC = ICC_WIN95_CLASSES;
	iccex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	InitCommonControlsEx(&iccex);

	/*pour le richedit qui permet de lire les fichiers*/
	InitialiserRKRichEdit( hInst);

	return TRUE;
}




/*------------------------------------------------------------------------
Procedure:     activerMenus ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void activerMenus (HWND hWnd, WORD wParam, LONG lParam )
{
	WORD iStatus;

	switch(lParam)
	{
	case MENU_ID_EDIT:  /*Edit Menu */
		/*Annuler*/
		EnableMenuItem ((HMENU) wParam, ITM_CHESS_UNDO,
			(GameCnt>0 ? MF_ENABLED : MF_GRAYED) );
		/*remove ?*/
		EnableMenuItem ((HMENU) wParam, ITM_CHESS_REMOVE,
			(GameCnt>1 ? MF_ENABLED : MF_GRAYED) );

		break;
	case MENU_ID_APP:
		/*Son*/
		if ( flag.beep == false)  iStatus = MF_UNCHECKED;
		else iStatus = MF_CHECKED;
		CheckMenuItem ((HMENU) wParam, ITM_CHESS_BEEP, iStatus);
		/*Coordonnes*/
		if ( !coords)  iStatus = MF_UNCHECKED;
		else iStatus = MF_CHECKED;
		CheckMenuItem ((HMENU) wParam, ITM_CHESS_COORD, iStatus);


		break;
	case MENU_ID_TOOLS:
		{  /* Options Menu */
			if ( flag.hash == false)  iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_HASH, iStatus);

			EnableMenuItem ((HMENU) wParam, ITM_CHESS_REVIEW,
				(GameCnt > 0 ? MF_ENABLED : MF_GRAYED) );


			if ( flag.bothsides == false)  iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_BOTH, iStatus);

			if ( Book == NULL)  iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_BOOK, iStatus);

			if ( flag.post == false)  iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_POST, iStatus);
		}
		break;
	case MENU_ID_SKILL:
		{
			if ( dither == 0)
				iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_RANDOM, iStatus);

			if ( flag.easy == false)
				iStatus = MF_CHECKED;
			else iStatus = MF_UNCHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_EASY, iStatus);

		}
		break;
	case MENU_ID_SIDE:
		{
			if ( flag.reverse == false)
				iStatus = MF_UNCHECKED;
			else iStatus = MF_CHECKED;
			CheckMenuItem ((HMENU) wParam, ITM_CHESS_REVERSE, iStatus);

			if ( computer == black )
			{
				CheckMenuItem ((HMENU) wParam, ITM_CHESS_BLACK, MF_CHECKED);
				CheckMenuItem ((HMENU) wParam, ITM_CHESS_WHITE, MF_UNCHECKED);
			}
			else
			    {
				CheckMenuItem ((HMENU) wParam, ITM_CHESS_WHITE, MF_CHECKED);
				CheckMenuItem ((HMENU) wParam, ITM_CHESS_BLACK, MF_UNCHECKED);
			}

		}
		break;
	}

}

/*------------------------------------------------------------------------
Procedure:     runUnique ID:1
Purpose: empche le double lancement et met la fentre au premier plan si ncessaire
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL runUnique(char *nom)
{
	HANDLE mutex_handle;
	HWND hwnd;
	int rtn;

	mutex_handle = CreateMutex(NULL, TRUE, nom);
	if (!mutex_handle)
	{
		return FALSE;
	}

	rtn = GetLastError();
	if (rtn == ERROR_ALREADY_EXISTS)
	{

		hwnd = FindWindow(nom, NULL);
		if (hwnd)
		{
			if (IsIconic(hwnd))
				ShowWindow(hwnd, SW_RESTORE);
			SetForegroundWindow(hwnd);
		}
		ReleaseMutex(mutex_handle);
		return FALSE;

	}

	ReleaseMutex(mutex_handle);

	return TRUE;
}



/*------------------------------------------------------------------------
Procedure:     ShowMessage ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ShowMessage ( HWND hWnd, int ident)
{
	char chaine[MAXCHAINE];
	/**/
	LoadString(hInst, ident, chaine, MAXCHAINE);
	MessageBox ( hWnd, chaine,szAppName , MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL );
}


/*------------------------------------------------------------------------
Procedure:     DisplayInfo ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL DisplayInfo(int Hnd, char *text)
{
	SendMessage(hStatusBar, SB_SETTEXT, Hnd | 0, (WPARAM)text);
	SendDlgItemMessage(hMain, BASEAFFICHE + Hnd, WM_SETTEXT, 0,(WPARAM)text);

	return TRUE;
}

/*------------------------------------------------------------------------
Procedure:     creerPolice ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static HFONT creerPolice(int taille, char*nomPolice)

{
	/*
	* code executable
	* ===============
	*/
	return CreateFont(
		taille,		// logical height of font
		0,		// logical average character width
		0,		// angle of escapement
		0,		// base-line orientation angle
		FW_NORMAL	,	// font weight
		FALSE,	// italic attribute flag
		FALSE,	// underline attribute flag
		FALSE,	// strikeout attribute flag
		DEFAULT_CHARSET,	// character set identifier
		OUT_DEFAULT_PRECIS,	// output precision
		CLIP_DEFAULT_PRECIS	,	// clipping precision
		DEFAULT_QUALITY	,	// output quality
		DEFAULT_PITCH|FF_MODERN,	// pitch and family
		nomPolice// pointer to typeface name string
		);
}

/*------------------------------------------------------------------------
Procedure:     creerAffichage ID:1
Purpose:
#define  BASEAFFICHE 8100
#define  HCOMPUTERCOLOR 0
#define  HWHOSTURN      1
#define  HCLOCKCOMPUTER 2
#define  HCLOCKHUMAN    3
#define  HCOMPUTERMOVE  4
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL creerAffichage(HWND hParent)
{

	static char *classe ={
		"static"
	};
	HWND hwnd;
	int  idx, idy;
	BOOL irep;


	/* Get the location of lower left conor of client area */
	hPolice = creerPolice(13, "tahoma");

	idx = 150;
	idy = 20;

	irep = TRUE;

	/*sera repositionn ailleurs*/
	/*Base*/


	/*l'ordinateur joue les.....*/
	hwnd = CreateWindow(
		classe,	// pointer to registered class name
		"",	// pointer to window name
		WS_CHILD|WS_VISIBLE|SS_SUNKEN|SS_CENTER,	// window style
		0,	// horizontal position of window
		0,	// vertical position of window
		idx,	// window width
		idy,	// window height
		hParent,	// handle to parent or owner window
		(HMENU) (BASEAFFICHE + HCOMPUTERCOLOR),	// handle to menu or child-window identifier
		hInst,	// handle to application instance
		NULL 	// pointer to window-creation data
		);
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hPolice, MAKELPARAM(FALSE, 0));

	if(hwnd == NULL) irep = FALSE;

	/*les ... ont le trait*/
	hwnd = CreateWindow(
		classe,	// pointer to registered class name
		"",	// pointer to window name
		WS_CHILD|WS_VISIBLE|SS_SUNKEN|SS_CENTER,	// window style
		0,	// horizontal position of window
		0,	// vertical position of window
		idx,	// window width
		idy,	// window height
		hParent,	// handle to parent or owner window
		(HMENU) (BASEAFFICHE + HWHOSTURN),	// handle to menu or child-window identifier
		hInst,	// handle to application instance
		NULL 	// pointer to window-creation data
		);
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hPolice, MAKELPARAM(FALSE, 0));
	if(hwnd ==NULL) irep = FALSE;

	/**/
	idx = 100;
	hwnd = CreateWindow(
		classe,	// pointer to registered class name
		"",	// pointer to window name
		WS_CHILD|WS_VISIBLE|SS_SUNKEN|SS_LEFT	,	// window style
		0,	// horizontal position of window
		0,	// vertical position of window
		idx,	// window width
		idy,	// window height
		hParent,	// handle to parent or owner window
		(HMENU) (BASEAFFICHE + HCLOCKCOMPUTER),	// handle to menu or child-window identifier
		hInst,	// handle to application instance
		NULL 	// pointer to window-creation data
		);
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hPolice, MAKELPARAM(FALSE, 0));
	if(hwnd ==NULL) irep = FALSE;

	/**/
	hwnd = CreateWindow(
		classe,	// pointer to registered class name
		"",	// pointer to window name
		WS_CHILD|WS_VISIBLE|SS_SUNKEN|SS_LEFT	,	// window style
		0,	// horizontal position of window
		0,	// vertical position of window
		idx,	// window width
		idy,	// window height
		hParent,	// handle to parent or owner window
		(HMENU) (BASEAFFICHE + HCLOCKHUMAN),	// handle to menu or child-window identifier
		hInst,	// handle to application instance
		NULL 	// pointer to window-creation data
		);
	SendMessage(hwnd, WM_SETFONT, (WPARAM) hPolice, MAKELPARAM(FALSE, 0));
	if(hwnd ==NULL) irep = FALSE;


	/**/
	hwnd = CreateWindow(
		classe,	// pointer to registered class name
		"",	// pointer to window name
		WS_CHILD|WS_VISIBLE|SS_SUNKEN|SS_LEFT	,	// window style
		0,	// horizontal position of window
		0,	// vertical position of window
		idx,	// window width
		idy,	// window height
		hParent,	// handle to parent or owner window
		(HMENU) (BASEAFFICHE + HCOMPUTERMOVE),	// handle to menu or child-window identifier
		hInst,	// handle to application instance
		NULL 	// pointer to window-creation data
		);
	SendMessage(hwnd, WM_SETFONT, (WPARAM)  hPolice, MAKELPARAM(FALSE, 0));
	if(hwnd == NULL) irep = FALSE;

	return irep;
}
/*------------------------------------------------------------------------
Procedure:     disposerAffichage ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL disposerAffichage(HWND hParent)
{
	HWND hwnd;
	RECT rc;
	int ix0, iy0;
	int  idx, idy;

	/*position de l'chiquier*/
	Board_queryPlacement ( &rc);
	idx = 150;
	idy = 20;

	/*label 1*/
	ix0 = (rc.left + rc.right)/2 - idx/2;
	iy0 = rc.top - idy - 32;

	hwnd = GetDlgItem(hParent, BASEAFFICHE + HCOMPUTERCOLOR);
	SetWindowPos(hwnd, NULL, ix0, iy0, 0, 0, SWP_NOZORDER|SWP_NOSIZE	);

	/*label 2*/
	iy0 = rc.bottom + 32;
	hwnd = GetDlgItem(hParent, BASEAFFICHE + HWHOSTURN);
	SetWindowPos(hwnd, NULL, ix0, iy0, 0, 0, SWP_NOZORDER|SWP_NOSIZE	);

	/*label 3*/
	ix0 = rc.right - CX_ICON;
	iy0 = rc.top - idy;
	idx = 100;
	iy0 = iy0 + idy + 4;
	hwnd = GetDlgItem(hParent, BASEAFFICHE + HCLOCKCOMPUTER);
	SetWindowPos(hwnd, NULL, ix0, iy0, 0, 0, SWP_NOZORDER|SWP_NOSIZE	);

	/*label 4*/
	iy0 = iy0 + idy + 32;
	hwnd = GetDlgItem(hParent, BASEAFFICHE + HCLOCKHUMAN);
	SetWindowPos(hwnd, NULL, ix0, iy0, 0, 0, SWP_NOZORDER|SWP_NOSIZE	);

	/*label 5*/
	iy0 = iy0 + idy + 32;
	hwnd = GetDlgItem(hParent, BASEAFFICHE + HCOMPUTERMOVE);
	SetWindowPos(hwnd, NULL, ix0, iy0, 0, 0, SWP_NOZORDER|SWP_NOSIZE	);

	return TRUE;
}
/*------------------------------------------------------------------------
Procedure:     moulinerMessages ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static int moulinerMessagesA(HACCEL hAccelTable)
{
	MSG msg;
	int irep;

	while (irep = GetMessage(&msg, NULL, 0,0))
	{
		if(irep == -1)
		{
			return irep;
		}
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

	}
	return (msg.wParam);
}

/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
Copyright (c) 1988, 1989, 1990  John Stanback

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/

