/*------------------------------------------------------------------------
Module:        c:\maison\codec\echec\board.c
Author:        Richard KIELBASA (adaptateur)
Project:       Echecs
State:         Termin
Creation Date: 8 12 2003
Description:  See at the end of file
Attention : l'origine d'une case est en bas  droite
------------------------------------------------------------------------*/

#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>
#include <stdio.h>
#include "clsimagelist.h"
#include "clsregistre.h"
//#include <rKControles.h>
//#include <debog.h>

/* All units defined in pixels */
/*Valeurs originelles*/
/*
#define BRD_SQRFRONT   48
#define BRD_HORZBACK    32
#define BRD_SQRVERT        32
#define BRD_EDGE        8 //paisseur de l'chiquier
#define BRD_HORZMARGIN  32
#define BRD_BACKMARGIN  5
#define BRD_FRONTMARGIN 5
*/
/*Valeurs exprimentales*/
#define BRD_OFFSETX 10
#define BRD_OFFSETY 100
#define BRD_SQRFRONT   68 /*largeur d'une case de la premire range (devant)*/
#define BRD_HORZBACK    32 /*largeur d'une case de la dernire range (derrire)*/
#define BRD_SQRVERT        32 /*hauteur d'une case*/
#define BRD_EDGE        8 /*paisseur de l'chiquier*/
#define BRD_HORZMARGIN  32 + 32 /*dcalage vers la droite*/
#define BRD_BACKMARGIN  5  /*marge arrire*/
#define BRD_FRONTMARGIN 5    /*marge avant*/

/*variables prives------------------------------------------------------*/

static unsigned long offsetX  = {
	BRD_OFFSETX};
static unsigned long offsetY  = {
	BRD_OFFSETY };
static unsigned long sqrFront = {
	BRD_SQRFRONT};
static unsigned long sqrBack  = {
	BRD_HORZBACK};
static unsigned long sqrVert  = {
	BRD_SQRVERT};
static unsigned long edge     = {
	BRD_EDGE};
static unsigned long horzMargin = {
	BRD_HORZMARGIN};
static unsigned long backMargin = {
	BRD_BACKMARGIN};
static unsigned long frontMargin = {
	BRD_FRONTMARGIN};

static char *lpOffsetX = {
	"OffsetX"};
static char *lpOffsetY = {
	"OffsetY"};
static char *lpSqrVert = {
	"SqrVert"};

static int deltay;
static HRGN hitrgn[8] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
static int hilitSq;

/*procdures prives-----------------------------------------------------*/
static void drawOneSquare ( HDC hDC, int x, int y);
static void initHit ( void );

/*------------------------------------------------------------------------
Procedure:     Board_setOrigine ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_setOrigine( UINT ix, UINT iy)
{
	offsetX   = ix - (2*horzMargin + 8*sqrFront)/2;
	offsetY   = iy - (backMargin + 8*sqrVert + 2*(frontMargin + edge))/2;

	initHit ( );
}

/*------------------------------------------------------------------------
Procedure:     Board_setSize ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_setSize( int iSize)
{
	int xc, yc;

	xc = offsetX + 4*sqrFront;
	yc = offsetY + 4*sqrVert ;
	switch(iSize)
	{
	case 1:
		sqrVert = 16;
		break;
	case 2:
		sqrVert = 32;
		break;
	case 3:
		sqrVert = 64;
		break;
	default:
		sqrVert = 32;
	}

	sqrBack = sqrVert;
	sqrFront = 2*sqrVert;

	offsetX   = xc - 4*sqrFront;
	offsetY   = yc - 4*sqrVert;

	initHit ();

}
/*------------------------------------------------------------------------
Procedure:     Board_queryPlacement ID:1
Purpose: La taille tient compte des marges avec un surplus (frontMargin + edge)
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_queryPlacement ( RECT *rc )
{
	rc->left = offsetX;
	rc->top = offsetY;
	rc->right =  offsetX + 2*horzMargin + 8*sqrFront;
	rc->bottom =  offsetY + backMargin + 8*sqrVert + 2*(frontMargin + edge);
}

/*------------------------------------------------------------------------
Procedure:     Board_querySqSize0 ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_querySqSize0 ( POINT *pptl )
{
	pptl->x = sqrFront;
	pptl->y = sqrVert;
}

/*------------------------------------------------------------------------
Procedure:     Board_querySqOrigin ID:1
Purpose: affect par le dcalage X0, Y0
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_querySqOrigin ( int i, int j, POINT *pptl)
{
	pptl->x = offsetX + horzMargin
	    + (j*(sqrFront - sqrBack))/2
	    +  (i*j*sqrBack + i*(8 - j)*sqrFront)/8;

	pptl->y = offsetY + backMargin   + frontMargin + (8 - j)*sqrVert;
}

/*------------------------------------------------------------------------
Procedure:     Board_querySqCoords ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_querySqCoords ( int i, int j, POINT aptl[] )
{
	Board_querySqOrigin ( i,   j,   aptl+0);//en bas  gauche
	Board_querySqOrigin ( i+1, j,   aptl+1);//en bas  droite
	Board_querySqOrigin ( i+1, j+1, aptl+2);// en haut  droite
	Board_querySqOrigin ( i,   j+1, aptl+3);// en haut  gauche
}

/*------------------------------------------------------------------------
Procedure:     drawOneSquare ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void drawOneSquare ( HDC hDC, int i, int j)
{
	POINT aptl[4];

	Board_querySqCoords ( i,j, aptl);
	Polygon( hDC, aptl, 4);
}



/*------------------------------------------------------------------------
Procedure:     Board_draw ID:1
Purpose:Draw the board.  Pass the routine the upper left connor and the
colors to draw the squares.
Input:
Output:BlackSquare
Errors:
------------------------------------------------------------------------*/
void Board_draw ( HDC hDC, int reverse, DWORD darkColor, DWORD lightColor )
{
	int i,j;
	int ii, jj;
	int OldPolyMode;
	HBRUSH hOldBrush;
	HBRUSH hBrush_lt, hBrush_dk;
	HPEN hOldPen, hPen;
	POINT aptl[4];


	hBrush_lt = CreateSolidBrush ( lightColor );
	hBrush_dk = CreateSolidBrush ( darkColor );

	hOldBrush = SelectObject ( hDC, hBrush_lt);
	/*Le trait est de la meme couleur que les cases fonces*/
	hPen = CreatePen(PS_SOLID, 1, darkColor);
	hOldPen   = SelectObject ( hDC, hPen );


	OldPolyMode = SetPolyFillMode ( hDC, WINDING );

	for (j = 0; j < 8; j++)
	{
		for (i = 0; i < 8; i++)
		{
			if ( reverse == 0 )
			{
				ii = i;
				jj = j;
			}
			else
			{
				ii = 7 - i;
				jj = 7 - j;
			}
			SelectObject ( hDC, ((ii + jj) & 1) ? hBrush_lt : hBrush_dk);
			drawOneSquare (hDC, ii, jj);
		}
	}

	/* Now draw the bottom edge of the board */

	for (i = 0; i < 8; i++)
	{
		Board_querySqCoords ( i, 0, aptl);

		aptl[2].x = aptl[1].x;
		aptl[2].y = aptl[1].y + edge;

		aptl[3].x = aptl[0].x;
		aptl[3].y = aptl[0].y + edge;

		SelectObject ( hDC, (i & 1) ? hBrush_lt : hBrush_dk);
		Polygon ( hDC, aptl, 4 );
	}
	SetPolyFillMode (hDC, OldPolyMode);

	SelectObject (hDC, hOldPen);
	SelectObject (hDC, hOldBrush);

	DeleteObject (hPen);
	DeleteObject ( hBrush_lt);
	DeleteObject ( hBrush_dk);
}

/*------------------------------------------------------------------------
Procedure:     Board_drawCoords ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_drawCoords ( HDC hDC, int reverse, DWORD clrBackGround, DWORD clrText)
{
	HFONT hFont, hOldFont;
	int i, OldBkMode;
	DWORD OldBkColor, OldTextColor;
	int xchar, ychar;
	int x0, y0;
	POINT pt;
	TEXTMETRIC tm;

	hFont = CreateFont ( 16, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, FIXED_PITCH | FF_SWISS, "ARIAL" );//HELV

	hOldFont = SelectObject ( hDC, hFont);
	OldBkColor = SetBkColor ( hDC, clrBackGround);
	OldBkMode = SetBkMode ( hDC, TRANSPARENT);
	OldTextColor = SetTextColor (hDC, clrText);

	GetTextMetrics ( hDC, &tm);
	xchar = tm.tmMaxCharWidth;
	ychar = tm.tmHeight;

	for ( i = 0; i < 8; i++)
	{
		Board_querySqOrigin (0, i, &pt );
		x0 = pt.x - xchar;
		y0 = pt.y - sqrVert/2 - ychar/2;
		TextOut (hDC, x0, y0,	(reverse ? "87654321"+i : "12345678"+i) ,1);

		Board_querySqOrigin (i,0, &pt );
		x0 =  pt.x + sqrFront/2 - xchar/2;
		y0 = pt.y + edge;
		TextOut (hDC, x0, y0,	(reverse ? "hgfedcba"+i : "abcdefgh"+i), 1);

	}

	SelectObject (hDC, hOldFont);
	DeleteObject ( hFont);

	SetBkColor ( hDC, OldBkColor);
	SetBkMode ( hDC, OldBkMode);
	SetTextColor (hDC, OldTextColor);
}


/*------------------------------------------------------------------------
Procedure:     Board_drawBackground ID:1
Purpose: pas utile si in position setwindowlong
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_drawBackground ( HDC hDC, HWND hWnd, DWORD bkcolor)
{
	RECT rect;
	HBRUSH hBrush, hOldBrush;

	hBrush = CreateSolidBrush ( bkcolor);
	hOldBrush = SelectObject ( hDC, hBrush);
	GetClientRect ( hWnd, &rect);
	FillRect ( hDC, &rect, hBrush);
	SelectObject ( hDC, hOldBrush);
	DeleteObject ( hBrush);
}

/*------------------------------------------------------------------------
Procedure:     Board_hiliteSquare ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_hiliteSquare ( HWND hWnd, int Square )
{
	HDC hDC;
	int i,j;
	POINT aptl[4];
	HRGN hRgn;

	j = Square / 8;
	i = Square % 8;

	Board_querySqCoords ( i,j, aptl+0);
	hRgn = CreatePolygonRgn( aptl, 4, WINDING);

	hDC = GetDC ( hWnd);
	InvertRgn ( hDC, hRgn );
	ReleaseDC ( hWnd, hDC );

	DeleteObject ( hRgn);
	hilitSq = Square;
}

/*------------------------------------------------------------------------
Procedure:     Board_unHiliteSquare ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_unHiliteSquare ( HWND hWnd, int Square )
{
	HDC hDC;
	int i,j;
	POINT aptl[4];
	HRGN hRgn;

	if ( hilitSq == -1 ) return;

	j = Square / 8;
	i = Square % 8;

	Board_querySqCoords ( i, j, aptl+0);
	hRgn = CreatePolygonRgn( aptl, 4, WINDING);

	hDC = GetDC ( hWnd);
	InvertRgn ( hDC, hRgn );
	ReleaseDC ( hWnd, hDC );

	DeleteObject ( hRgn);

	hilitSq = -1;
}
/*------------------------------------------------------------------------
Procedure:     Board_drawLight ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL Board_drawLight(HDC hDC, int dispo, int tour)
{

	POINT pointbas, pointhaut;
	int ibas, ihaut;
	int ixbas, ixhaut, iybas, iyhaut;

	//Board_queryPlacement ( &rc );CX_ICON
	Board_querySqOrigin ( 0,   0,  & pointbas);//en bas  gauche
	Board_querySqOrigin ( 0,  7+1,  &pointhaut);// en haut  gauche

	ixbas = pointbas.x - CX_ICON;
	iybas = pointbas.y - CX_ICON;
	ixhaut = pointhaut.x - CX_ICON;
	iyhaut = pointhaut.y - CX_ICON;
	//MsgBoxI(tour,"coucou");

	if (((!tour ) && (dispo)) || ((tour ) && (!dispo)))
	{
		ibas = 1;
		ihaut = 0;

	}
	else
	    {

		ibas = 0;
		ihaut = 1;
	}


	Images_drawIcon(hDC, ibas, ixbas, iybas);
	Images_drawIcon(hDC, ihaut, ixhaut, iyhaut);


	return TRUE;
}
/*------------------------------------------------------------------------
Procedure:     Board_hitinit ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void initHit ( void )
{
	POINT ptls[4];
	POINT toppt, botpt;
	int i;

	for (i = 0; i < 8; i++)
	{
		if (hitrgn[i] != NULL)
			DeleteObject ( hitrgn[i] );
		Board_querySqOrigin ( i, 0, ptls+0 );
		Board_querySqOrigin ( i, 8, ptls+1 );
		Board_querySqOrigin ( i+1, 8, ptls+2 );
		Board_querySqOrigin ( i+1, 0, ptls+3 );
		hitrgn[i] = CreatePolygonRgn ( ptls, 4, WINDING);
	}
	Board_querySqOrigin ( 0, 0, &botpt );
	Board_querySqOrigin ( 0, 8, &toppt );
	deltay = botpt.y - toppt.y;

}


/*------------------------------------------------------------------------
Procedure:     Board_delHit ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_delHit (void)
{
	int i;

	for (i = 0; i < 8; i++)
	{
		if (hitrgn[i] != NULL)
			DeleteObject ( hitrgn[i] );
	}
}


/*------------------------------------------------------------------------
Procedure:     horzHitTest ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static int horzHitTest ( int x, int y)
{
	int i;

	for ( i = 0; i < 8; i++)
	{
		if ( PtInRegion ( hitrgn[i], x, y) ) return i;
	}
	return -1;
}


/*------------------------------------------------------------------------
Procedure:     Board_getSquare ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int Board_getSquare ( int x, int y)
{
	int xsq, ysq;
	POINT sq00;

	xsq = horzHitTest ( x, y );
	if (xsq == -1) return -1;

	Board_querySqOrigin ( 0, 0, &sq00);

	if ( y > sq00.y ) return -1;

	if ( y < (sq00.y - deltay) ) return -1;

	ysq = 7 - (y - (sq00.y - deltay) ) / (deltay/8);

	return ( ysq*8 + xsq );
}


/*------------------------------------------------------------------------
Procedure:     Board_saveInReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_saveInReg ( char *appname )
{

	if(!REG_ouvrirAcces(appname, NULL)) return;

	REG_preserverDWORD(lpOffsetX, offsetX);
	REG_preserverDWORD(lpOffsetY, offsetY);
	REG_preserverDWORD(lpSqrVert, sqrVert);

	REG_fermerAcces();
}
/*------------------------------------------------------------------------
Procedure:     Board_getFromReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Board_getFromReg ( char *appname )
{

	if(!REG_ouvrirAcces(appname, NULL)) return;

	REG_recupererDWORD(lpOffsetX, &offsetX);
	REG_recupererDWORD(lpOffsetY, &offsetY);
	REG_recupererDWORD(lpSqrVert, &sqrVert);

	REG_fermerAcces();

	sqrBack = sqrVert;
	sqrFront = 2*sqrVert;

	initHit ();
}

