/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\clsregistre.c
 Author:        Richard KIELBASA
 Project:       Echecs
 State:         Termin
 Creation Date: 21 2 2002
 Description:   Prservation du contexte dans la base de
                registres

------------------------------------------------------------------------*/

#include <windows.h>

/*--------------------------------clsRegistre---------------------------*/
#include "clsRegistre.h"
/*objets privs---------------------------------------------------------*/
static HKEY hCleAppli = NULL;
/*------------------------------------------------------------------------
Procedure:     enregistrerApplication ID:1
Purpose:       Enregistrer application
stocke les donnes par dfaut du logiciel dans la
base de regsitre lors de la premire utilisation.
ouvre l'accs au registre lors des excutions
ultrieures
ne jamais modifier cette base de registre
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_ouvrirAcces(char * nomCle, BOOL (*initFct) (void))
{
	/*
	* declaration des variables locales
	* =================================
	*/
	char  chaine[256];
	DWORD  dwDisposition;
	LONG   lRetCode;

	/*
	* code executable
	* ===============
	*/
	/*arbre d'accs   la cl du logiciel*/
	strcpy (chaine, "Software\\");
	strcat(chaine, nomCle);

	/*crer l'entre relative  l'application*/
	lRetCode = RegCreateKeyEx (HKEY_CURRENT_USER, chaine,
		0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
		NULL, &hCleAppli, &dwDisposition);
	if (lRetCode != ERROR_SUCCESS)
	{
		return FALSE;
	}
	/*s'il y a cration valeur par dfaut des cls*/
	if (dwDisposition == REG_CREATED_NEW_KEY)
	{
		if(initFct != NULL)
			initFct();

	}

	return TRUE;
}

/*------------------------------------------------------------------------
Procedure:     REG_recupererChaine ID:1
Purpose:

Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_recupererChaine (char * nomInfo, char * chaine, unsigned int nbCar )
{
	/*
	* declaration des variables locales
	* =================================
	*/

	/*
	* code executable
	* ===============
	*/
	RegQueryValueEx(
		hCleAppli,	// handle of key to query
		nomInfo,	// address of name of value to query
		0,	// reserved
		NULL,	// address of buffer for value type
		chaine,	// address of data buffer
		&nbCar );	// address of data buffer size


	return TRUE;

}

/*------------------------------------------------------------------------
Procedure:     preserverInfo ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_preserverChaine( char * nomInfo, char * chaine)
{
	/*
	* declaration des variables locales
	* =================================
	*/
	int lgn;

	/*
	* code executable
	* ===============
	*/
	lgn = strlen(chaine) + 1;

	RegSetValueEx(
		hCleAppli,	// handle of key to set value for
		nomInfo,	// address of value to set
		0,	// reserved
		REG_SZ,	// flag for value type
		chaine,	// address of value data
		lgn );// size of value data


	return TRUE;

}

/*------------------------------------------------------------------------
Procedure:     REG_preserverDWORD ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_preserverDWORD(char *nomInfo, DWORD dwData)
{

	/*
	* declaration des variables locales
	* =================================
	*/
	ULONG irep;

	/*
	* code executable
	* ===============
	*/
	irep = RegSetValueEx(hCleAppli, nomInfo, 0, REG_DWORD, &dwData, sizeof(DWORD));

	if(irep == ERROR_SUCCESS)
		return TRUE;
	else
	    return FALSE;
}


/*------------------------------------------------------------------------
Procedure:     REG_recupererDWORD ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_recupererDWORD(char *nomInfo, DWORD *dwValue)
{

	/*
	* declaration des variables locales
	* =================================
	*/
	DWORD dwType, dwByte;
	ULONG irep;
	/*
	* code executable
	* ===============
	*/
	dwType = REG_DWORD;
	dwByte = 32;
	irep = RegQueryValueEx(hCleAppli, nomInfo, NULL, &dwType, (BYTE *)dwValue, &dwByte);

	if(irep == ERROR_SUCCESS)
		return TRUE;
	else
	    return FALSE;
}
/*------------------------------------------------------------------------
Procedure:     REG_fermerAcces ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL REG_fermerAcces(void)
{

	/*
	* declaration des variables locales
	* =================================
	*/
	ULONG irep;
	/*
	* code executable
	* ===============
	*/
	irep = RegCloseKey(hCleAppli);
	hCleAppli = NULL;

	if(irep == ERROR_SUCCESS)
		return TRUE;
	else
	    return FALSE;
}
