/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\DISPLAY.C
 Author:        Richard KIELBASA  (adaptateur)
 Project:       Echecs
 State:         En cours
 Creation Date: 18 12 2003
 Description:   See at the end of file

------------------------------------------------------------------------*/


#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>
#include <string.h>
#include <time.h>
#include <stdio.h>

//#include <debog.h>

#include "gnuchess.h"
#include "display.h"
#include "search.h"
#include "board.h"
#include "mainechecs.h"
#include "frmstats.h"
#include "Echecs_rc.h"
#include "initiali.h"
#include "clsregistre.h"

/*
static int  Stboard[64] =
{rook, knight, bishop, queen, king, bishop, knight, rook,
pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
pawn, pawn, pawn, pawn, pawn, pawn, pawn, pawn,
rook, knight, bishop, queen, king, bishop, knight, rook};

static int  Stcolor[64] =
{white, white, white, white, white, white, white, white,
white, white, white, white, white, white, white, white,
2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
black, black, black, black, black, black, black, black,
black, black, black, black, black, black, black, black};
*/

/*variables publiques----------------------------------------------*/
int Display_board[64];       /* Display copies of the board */
int Display_color[64];       /* Needed because while computer is calculating*/
/* moves it updates board and color thus you can*/
/* not repaint the screen accuratly */
char *Display_moveString;
BOOL Display_StatBarOn = TRUE; //Statusleiste standardmig an
long Display_evrate;

/*variables prives-------------------------------------------------*/
static char * lpWinLeft = {
	"WinLeft"};
static char * lpWinTop = {
	"WinTop"};
static char * lpWinRight = {
	"WinRight"};
static char * lpWinBottom = {
	"WinBottom"};
static char  *lpStatusBar  = "StatusBar";
static char  *lpZeitLimit   = "ZeitLimit";

#define pxx " PNBRQK"
#define qxx " pnbrqk"

/*procdures prives-------------------------------------------------*/
static char mvstr[4][6];
static void drawPiece ( HWND hWnd, int f );


/*------------------------------------------------------------------------
Procedure:     makeMoveString ID:1
Purpose:  Generate move strings in different formats. Formerly : algbr()
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void makeMoveString (int f, int t, int flag)

{
	int m3p;

	if (f != t)
	{
		/* algebraic notation */
		mvstr[0][0] = (char) ('a'+column (f));
		mvstr[0][1] = (char) ('1'+row (f));
		mvstr[0][2] = (char) ('a'+column (t));
		mvstr[0][3] = (char) ('1'+row (t));
		mvstr[0][4] = mvstr[3][0] = '\0';
		if ((mvstr[1][0] = pxx[board[f]]) == 'P')
		{
			if (mvstr[0][0] == mvstr[0][2])       /* pawn did not eat */
			{
				mvstr[2][0] = mvstr[1][0] = mvstr[0][2];  /* to column */
				mvstr[2][1] = mvstr[1][1] = mvstr[0][3];  /* to row */
				m3p = 2;
			}
			else
				/* pawn ate */
			{
				mvstr[2][0] = mvstr[1][0] = mvstr[0][0];  /* from column */
				mvstr[2][1] = mvstr[1][1] = mvstr[0][2];  /* to column */
				mvstr[2][2] = mvstr[0][3];
				m3p = 3;          /* to row */
			}
			mvstr[2][m3p] = mvstr[1][2] = '\0';
			if (flag & promote)
			{
				mvstr[0][4] = mvstr[1][2] = mvstr[2][m3p] = qxx[flag & pmask];
				mvstr[1][3] = mvstr[2][m3p + 1] = mvstr[0][5] = '\0';
			}
		}
		else
		    /* not a pawn */
		{
			mvstr[2][0] = mvstr[1][0];
			mvstr[2][1] = mvstr[0][1];
			mvstr[2][2] = mvstr[1][1] = mvstr[0][2];      /* to column */
			mvstr[2][3] = mvstr[1][2] = mvstr[0][3];      /* to row */
			mvstr[2][4] = mvstr[1][3] = '\0';
			strcpy (mvstr[3], mvstr[2]);
			mvstr[3][1] = mvstr[0][0];
			if (flag & cstlmask)
			{
				if (t > f)
				{
					strcpy (mvstr[1], "o-o");
					strcpy (mvstr[2], "O-O");
				}
				else
				    {
					strcpy (mvstr[1], "o-o-o");
					strcpy (mvstr[2], "O-O-O");
				}
			}
		}
	}
	else
	    {
		mvstr[0][0] = mvstr[1][0] = mvstr[2][0] = mvstr[3][0] = '\0';
	}

	/*exposition de la chaine 0*/
	Display_moveString = mvstr[0];
	return;

}

/*------------------------------------------------------------------------
Procedure:     VerifyMove ID:1
Purpose:       Compare the string 's' to the list of legal moves available for the
opponent. If a match is found, make the move on the board.
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int VerifyMove (HWND hWnd, char *str, int iop, unsigned int *mv)

{
	static int pnt, tempb, tempc, tempsf, tempst, cnt;
	static struct leaf xnode;
	struct leaf   *node;

	*mv = 0;
	if (iop == 2)
	{
		UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);
		return (false);
	}
	cnt = 0;
	MoveList (opponent, 2);
	pnt = TrPnt[2];
	while (pnt < TrPnt[3])
	{
		node = &Tree[pnt++];
		makeMoveString (node->f, node->t, (int) node->flags);


		if (strcmp (str, mvstr[0]) == 0 || strcmp (str, mvstr[1]) == 0 ||
			    strcmp (str, mvstr[2]) == 0 || strcmp (str, mvstr[3]) == 0)
		{
			cnt++;
			xnode = *node;
		}



	}
	if (cnt == 1)
	{
		MakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst, &INCscore);
		if (SqAtakd (PieceList[opponent][0], computer))
		{
			UnmakeMove (opponent, &xnode, &tempb, &tempc, &tempsf, &tempst);

			ShowMessage (hWnd, ITT_ILLEGALMOVE);

			return (false);
		}
		else
		    {
			if (iop == 1)
				return (true);
			UpdateDisplay (hWnd, xnode.f, xnode.t, 0, (int) xnode.flags);
			if ((board[xnode.t] == pawn)
				    || (xnode.flags & capture)
				    || (xnode.flags & cstlmask))
			{
				Game50 = GameCnt;
				ZeroRPT ();
			}
			GameList[GameCnt].depth = GameList[GameCnt].score = 0;
			GameList[GameCnt].nodes = 0;
			ElapsedTime (1);
			GameList[GameCnt].time = (int) et;
			TimeControl.clock[opponent] -= et;
			--TimeControl.moves[opponent];
			*mv = (xnode.f << 8) | xnode.t;
			makeMoveString (xnode.f, xnode.t, false);
			return (true);
		}
	}
	if (cnt > 1) ShowMessage (hWnd, ITT_AMBIGUOUSMOVE);

	return (false);
}

/*------------------------------------------------------------------------
Procedure:     ElapsedTime ID:1
Purpose:       Determine the time that has passed since the search was started. If
the elapsed time exceeds the target (ResponseTime+ExtraTime) then set
timeout to true which will terminate the search.
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ElapsedTime (int iop)
{
	et = time ((unsigned long *) 0) - time0;
	if (et < 0)
		et = 0;
	ETnodes += 50;
	if (et > et0 || iop == 1)
	{
		if (et > ResponseTime + ExtraTime && Sdepth > 1)
			flag.timeout = true;
		et0 = et;
		if (iop == 1)
		{
			time0 = time ((unsigned long *) 0);
			et0 = 0;
		}
		if (et > 0)
			/* Display_evrate used to be Nodes / cputime I dont` know why */
			Display_evrate = NodeCnt / (et + ft);
		else
		    Display_evrate = 0;
		ETnodes = NodeCnt + 50;
		UpdateClocks ();
		if (flag.post)
			Stats_ShowNodeCnt (NodeCnt, Display_evrate);
	}
}

/*------------------------------------------------------------------------
Procedure:     SetTimeControl ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void SetTimeControl (void)
{
	if (TCflag)
	{
		TimeControl.moves[white] = TimeControl.moves[black] = TCmoves;
		TimeControl.clock[white] = TimeControl.clock[black] = 60 * (long) TCminutes;
	}
	else
	    {
		TimeControl.moves[white] = TimeControl.moves[black] = 0;
		TimeControl.clock[white] = TimeControl.clock[black] = 0;
		Level = 60 * (long) TCminutes;
	}
	et = 0;
	ElapsedTime (1);
}

/*------------------------------------------------------------------------
Procedure:     Undo ID:1
Purpose:       Undo the most recent half-move.
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Undo (HWND hWnd)

{
	int f, t;



	f = GameList[GameCnt].gmove >> 8;
	t = GameList[GameCnt].gmove & 0xFF;
	if (board[t] == king && distance (t, f) > 1)
		(void) castle (GameList[GameCnt].color, f, t, 2);
	else
	    {
		/* Check for promotion: */
		if ((color[t] == white && row (f) == 6 && row (t) == 7)
			    || (color[t] == black && row (f) == 1 && row (t) == 0))
		{
			int g, from = f;
			for (g = GameCnt - 1; g > 0; g--)
				if (GameList[g].gmove & 0xFF == from)
					from = GameList[g].gmove >> 8;
			if ((color[t] == white && row (from) == 1)
				    || (color[t] == black && row (from) == 6))
				board[t] = pawn;
		}
		board[f] = board[t];
		color[f] = color[t];
		board[t] = GameList[GameCnt].piece;
		color[t] = GameList[GameCnt].color;
		if (color[t] != neutral)
			Mvboard[t]--;
		Mvboard[f]--;
	}
	if (TCflag)
		++TimeControl.moves[color[f]];
	GameCnt--;
	computer = otherside[computer];
	opponent = otherside[opponent];
	flag.mate = false;
	Sdepth = 0;
	UpdateDisplay (hWnd, 0, 0, 1, 0);
	InitializeStats ();

}
/*------------------------------------------------------------------------
Procedure:     ShowPlayers ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ShowPlayers (void)
{
	char chaine[MAXCHAINE];

	/* display in the status line what color the computer is playing */

	LoadString(hInst, ((computer == black) ? ITT_ORDNOIR : ITT_ORDBLANC), chaine, MAXCHAINE);
	DisplayInfo(HCOMPUTERCOLOR, chaine);

}

/*------------------------------------------------------------------------
Procedure:     ShowSidetoMove ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ShowSidetoMove (HWND hwnd)
{
	char chaine[MAXCHAINE];
	HDC hDC;

	LoadString(hInst, (player == white) ? ITT_BLANCTRAIT : ITT_NOIRTRAIT, chaine, MAXCHAINE);
	DisplayInfo( HWHOSTURN, chaine);
	hDC = GetDC(hwnd);
	Board_drawLight( hDC, flag.reverse, player == white);
	ReleaseDC(hwnd, hDC);
}

/*------------------------------------------------------------------------
Procedure:     ShowGameCount ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void ShowGameCount (HWND hwnd)
{
	char chaine[MAXCHAINE];

	sprintf(chaine, "GameCnt = %d", GameCnt);
	DisplayInfo( HGAMECNT, chaine);

}

/*------------------------------------------------------------------------
Procedure:     OutputMove ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void OutputMove (HWND hWnd)
{
	char tmp[8];
	char chaine[MAXCHAINE];
	int ident;

	UpdateDisplay (hWnd, root->f, root->t, 0, (int) root->flags);
	LoadString(hInst, ITT_MONCOUP, chaine, MAXCHAINE);
	sprintf ( tmp, " %s", (char *) mvstr[0]);
	strcat(chaine, tmp);
	DisplayInfo( HCOMPUTERMOVE, chaine);

	ident = 0;
	if (root->flags & draw)
		ident = ITT_DRAWGAME;
	else if (root->score == -9999)
		ident = ITT_YOUWIN;
	else if (root->score == 9998)
		ident = ITT_COMPUTERWIN;
	else if (root->score < -9000)
		ident = ITT_MATESOON;
	else if (root->score > 9000)
		ident = ITT_COMPMATE;
	else
	    return;
	// goto skip;


	ShowMessage ( hWnd, ident);
	/*externalis*/
	//skip:
	//if (flag.post)
	//{
	//	Stats_ShowNodeCnt (NodeCnt, Display_evrate);

	//}
}

/*------------------------------------------------------------------------
Procedure:     UpdateClocks ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void UpdateClocks (void)
{
	int m, s;
	char chaine[MAXCHAINE];
	char tmp[20];

	m = (int) (et / 60);
	s = (int) (et - 60 * (long) m);
	if (TCflag)
	{
		m = (int) ((TimeControl.clock[player] - et) / 60);
		s = (int) (TimeControl.clock[player] - et - 60 * (long) m);
	}
	if (m < 0) m = 0;
	if (s < 0) s = 0;

	sprintf ( tmp, " %0d:%02d", m, s);

	if ( player == computer )
	{
		m = ITT_CLOCKCOMPUTER;
		s = HCLOCKCOMPUTER;
	}
	else
	    {
		m = ITT_CLOCKHUMAN;
		s = HCLOCKHUMAN;
		MessageBeep (0);
	}

	LoadString(hInst, m, chaine, MAXCHAINE);
	strcat(chaine, tmp);
	DisplayInfo (s, chaine);

	/*externalis*/
	//if (flag.post)
	//Stats_ShowNodeCnt (NodeCnt, Display_evrate);
}


/*------------------------------------------------------------------------
Procedure:     drawPiece ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void drawPiece ( HWND hWnd, int f )
{
	POINT aptl[4];
	int i,j;
	RECT rc;

	if ( flag.reverse )
	{
		i = 7-(f%8);
		j = 7-(f/8);
	}
	else {
		i = f%8;
		j = f/8;
	}
	/*
	Board_querySqCoords ( i, j, aptl);
	hRgn = CreatePolygonRgn( aptl, 4, WINDING);
	InvalidateRgn ( hWnd, hRgn, FALSE );
	DeleteObject ( hRgn);
	*/
	/*rectangle rendu ncessaire par la taille variable des pieces
	( aptl 0) en bas  gauche
	( aptl 1) en bas  droite
	( aptl 2)  en haut  droite
	( aptl 3)  en haut  gauche
	la hauteur de l'image piece est gale  sa largeur, elle est gale  la hauteur de la case
	*/

	Board_querySqCoords ( i, j, aptl);
	rc.left = aptl[0].x;
	rc.top = aptl[0].y - (aptl[0].y -  aptl[2].y);
	rc.right =  aptl[1].x ;
	rc.bottom = aptl[0].y;
	InvalidateRect(hWnd, &rc, FALSE);

}


/*------------------------------------------------------------------------
Procedure:     UpdateDisplay ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void UpdateDisplay (HWND hWnd, int f, int t, int redraw, int isspec)
{
	int sq;

	for (sq = 0; sq < 64; sq++)
	{
		Display_board[sq] = board[sq];
		Display_color[sq] = color[sq];
	}

	if (redraw)
	{
		InvalidateRect ( hWnd, NULL, TRUE);
		ShowPlayers ();
		UpdateWindow ( hWnd );
	}
	else
	    {
		drawPiece (hWnd, f);
		drawPiece (hWnd, t);
		if (isspec & cstlmask)
			if (t > f)
			{
				drawPiece (hWnd, f + 3);
				drawPiece (hWnd, t - 1);
			}
		else
		    {
			drawPiece (hWnd, f - 4);
			drawPiece (hWnd, t + 1);
		}
		else if (isspec & epmask)
		{
			drawPiece (hWnd, t - 8);
			drawPiece (hWnd, t + 8);
		}
		UpdateWindow (hWnd);
	}
}

/*------------------------------------------------------------------------
Procedure:     SearchStartStuff ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void SearchStartStuff (int side)
{
	return;
}

/*------------------------------------------------------------------------
Procedure:     GiveHint ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void GiveHint (HWND hwnd)
{
	/*
	* declaration des variables locales
	* =================================
	*/
	MSGBOXPARAMS mgb;
	char chaine[MAXCHAINE];

	/*
	* code executable
	* ===============
	*/
	makeMoveString ((int) (hint >> 8), (int) (hint & 0xFF), false);

	LoadString(hInst, ITT_TRY, chaine, MAXCHAINE);
	strcat (chaine, mvstr[0]);

	mgb.cbSize = sizeof(MSGBOXPARAMS);
	mgb.hwndOwner = hwnd;
	mgb.hInstance = hInst;
	mgb.lpszText = chaine;
	mgb.lpszCaption = szAppName;
	mgb.dwStyle = MB_USERICON;
	mgb.lpszIcon = MAKEINTRESOURCE(ICO_CHESS);
	mgb.dwContextHelpId = 0;
	mgb.lpfnMsgBoxCallback = NULL;
	mgb.dwLanguageId = MAKELANGID(LANG_FRENCH	,SUBLANG_FRENCH);

	MessageBoxIndirect(&mgb);

}
/*------------------------------------------------------------------------
Procedure:     Display_getFromReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
BOOL Display_getFromReg ( char *appname, RECT *rc )
{
	if(!REG_ouvrirAcces(appname, NULL)) return FALSE;


	REG_recupererDWORD(lpWinLeft, (DWORD*)&(rc->left));
	REG_recupererDWORD(lpWinTop, (DWORD*)&(rc->top));
	REG_recupererDWORD(lpWinRight, (DWORD*)&(rc->right));
	REG_recupererDWORD(lpWinBottom, (DWORD*)&(rc->bottom));
	REG_recupererDWORD(lpStatusBar,(DWORD*) &Display_StatBarOn);
	REG_recupererDWORD(lpZeitLimit, (DWORD*) &TCminutes);


	REG_fermerAcces();

	return TRUE;
}

/*------------------------------------------------------------------------
Procedure:     Display_saveInReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Display_saveInReg ( char *appname, RECT *rc )
{

	if(!REG_ouvrirAcces(appname, NULL)) return;

	REG_preserverDWORD(lpWinLeft, rc->left);
	REG_preserverDWORD(lpWinTop, rc->top);
	REG_preserverDWORD(lpWinRight, rc->right);
	REG_preserverDWORD(lpWinBottom, rc->bottom);

	REG_preserverDWORD(lpStatusBar, Display_StatBarOn);
	REG_preserverDWORD(lpZeitLimit, TCminutes);

	REG_fermerAcces();
}
/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

Copyright (C) 1986, 1987, 1988, 1989, 1990 Free Software Foundation, Inc.
Copyright (c) 1988, 1989, 1990  John Stanback

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/

