/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\frmcolor.c
 Author:        Richard KIELBASA  (adaptateur)
 Project:       Echecs
 State:         Termin
 Creation Date: 12 dec 2003 19:41:39
 Description:   See at the end of file
------------------------------------------------------------------------*/

#include <windows.h>
//#include <debog.h>
//#include <RKControles.h>
#include "clsregistre.h"
#include "frmcolor.h"
#include "clsimagelist.h"
#include "Echecs_rc.h"


/*couleur 'bois' 'wood'*/
#define DEF_BACKGROUND (0x00ffc4c4)
#define DEF_BLACKSQUARE (0x00004080)
#define DEF_WHITESQUARE (0x00aec8d2)
#define DEF_BLACKPIECE (0x005e8295)
#define DEF_WHITEPIECE (0x00c2cfda)
#define DEF_TEXT (0x00000000)

COLORREF clrBackGround;       /* rgb structures for various colors */
COLORREF clrBlackSquare;
COLORREF clrWhiteSquare;
COLORREF clrBlackPiece;
COLORREF clrWhitePiece;
COLORREF clrText;
/**/
/*Dclarations prives--------------------------------------------------*/
/*Variables prives-----------------------------------------------------*/
/*identificateur de la base de registres*/
static char  lpBackGround[]  = "BackGround";
static char  lpBlackSquare[] = "BlackSquare";
static char  lpWhiteSquare[] = "WhiteSquare";
static char  lpBlackPiece[]  = "BlackPiece";
static char  lpWhitePiece[]  = "WhitePiece";
static char  lpText[]        = "Text";


static HBRUSH  g_hBrush = NULL;
static COLORREF locBackGround;
static COLORREF locBlackSquare;
static COLORREF locWhiteSquare;
static COLORREF locBlackPiece;
static COLORREF locWhitePiece;
static COLORREF locText;

static COLORREF*  ptTypeColChecked = 0;

static int initFrmColor(HWND, WPARAM, LPARAM);
static BOOL CALLBACK gererFrmColor(HWND, UINT, WPARAM, LPARAM);
/*------------------------------------------------------------------------
Procedure:     Color ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int appelColor( HINSTANCE hInst, HWND hwndParent)
{

	/*
	* declaration des variables locales
	* =================================
	*/
	int result;

	/*
	* code executable
	* ===============
	*/
	result = DialogBoxParam(hInst, MAKEINTRESOURCE(DLG_COLO), hwndParent, (DLGPROC) gererFrmColor, (LPARAM)0);
	return result;
}
/*------------------------------------------------------------------------
Procedure:     Color ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static int initFrmColor(HWND hwndDlg, WPARAM wParam, LPARAM lParam)
{

	/*
	* declaration des variables locales
	* =================================
	*/

	SendDlgItemMessage(hwndDlg,  RDB_COL_FOND, BM_SETCHECK, BST_CHECKED, 0);

	locBackGround = clrBackGround;
	locBlackSquare = clrBlackSquare;
	locWhiteSquare = clrWhiteSquare;
	locBlackPiece = clrBlackPiece;
	locWhitePiece = clrWhitePiece;
	locText = clrText;

	ptTypeColChecked = &locBackGround;

	return 1;
}
/*------------------------------------------------------------------------
Procedure:     Color ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL CALLBACK gererFrmColor(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{

	/*
	* declaration des variables locales
	* =================================
	*/

	/*
	* code executable
	* ===============
	*/

	switch (msg)
	{
	case WM_INITDIALOG:
		initFrmColor(hwndDlg, wParam, lParam);
		return TRUE;
	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case RDB_COL_FOND:
			ptTypeColChecked = &locBackGround;
			break;
		case RDB_COL_CASN:
			ptTypeColChecked = &locBlackSquare;
			break;
		case RDB_COL_CASB:
			ptTypeColChecked = &locWhiteSquare;
			break;
		case RDB_COL_PIECN:
			ptTypeColChecked = &locBlackPiece;
			break;
		case RDB_COL_PIECB:
			ptTypeColChecked = &locWhitePiece;
			break;
		case RDB_COL_TEXTE:
			ptTypeColChecked = &locText;
			break;

		case CMD_COL_MODIF:
			{
				CHOOSECOLOR chcol;

				COLORREF tab[16];
				for (int i = 0; i < 16; i++)
				{
					tab[i] = 0;
				}

				chcol.lStructSize = sizeof(CHOOSECOLOR);
				chcol.hwndOwner = hwndDlg;
				chcol.hInstance = NULL;
				chcol.rgbResult = *ptTypeColChecked ;
				chcol.lpCustColors = &(tab[0]);
				chcol.Flags = CC_RGBINIT ;
				chcol.lCustData = 0;
				chcol.lpfnHook = NULL;
				chcol.lpTemplateName = NULL;


				ChooseColor(&chcol);
				*ptTypeColChecked = chcol.rgbResult ;
				InvalidateRect (hwndDlg, NULL, TRUE);
			}

			break;
		case CMD_COL_VALID:
			clrBackGround = locBackGround;
			clrBlackSquare = locBlackSquare;
			clrWhiteSquare = locWhiteSquare;
			clrBlackPiece = locBlackPiece;
			clrWhitePiece = locWhitePiece;
			clrText = locText;
			if(g_hBrush) DeleteObject(g_hBrush );
			g_hBrush = NULL;
			Images_setPieceColor();
			EndDialog(hwndDlg, 0);
			break;

		case CMD_COL_ANNUL:
			if(g_hBrush) DeleteObject(g_hBrush );
			g_hBrush = NULL;
			EndDialog(hwndDlg, 0);
			break;

		}
		break;
	case WM_CTLCOLORSTATIC :
		{
			COLORREF iColor;
			int id;

			id = GetDlgCtrlID((HWND) lParam);
			switch(id)
			{
			case LBL_COL_FOND:
				iColor = locBackGround;
				break;
			case LBL_COL_CASN:
				iColor = locBlackSquare;
				break;
			case LBL_COL_CASB:
				iColor = locWhiteSquare;
				break;
			case LBL_COL_PIECN:
				iColor = locBlackPiece;
				break;
			case LBL_COL_PIECB:
				iColor =  locWhitePiece;
				break;
			case LBL_COL_TEXTE:
				iColor = locText;
				break;
			default:
				return TRUE;
			}
			if(g_hBrush) DeleteObject(g_hBrush );
			g_hBrush = CreateSolidBrush(iColor);

			return (BOOL) g_hBrush;
		}
		break;
	case WM_CLOSE:
		if(g_hBrush) DeleteObject(g_hBrush );
		g_hBrush = NULL;
		EndDialog(hwndDlg, 0);
		return TRUE;
	}
	return FALSE;
}

/*------------------------------------------------------------------------
Procedure:     Color_setStandard ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Color_setStandard ( void)
{
	clrBackGround =  DEF_BACKGROUND;
	clrBlackSquare = DEF_BLACKSQUARE;
	clrWhiteSquare = DEF_WHITESQUARE;
	clrBlackPiece  = DEF_BLACKPIECE;
	clrWhitePiece  = DEF_WHITEPIECE;
	clrText        = DEF_TEXT;
}

/*------------------------------------------------------------------------
Procedure:     Color_saveInReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Color_saveInReg ( LPSTR appname )
{

	if(!REG_ouvrirAcces(appname, NULL)) return;


	REG_preserverDWORD(lpBackGround, clrBackGround);
	REG_preserverDWORD(lpBlackSquare, clrBlackSquare);
	REG_preserverDWORD(lpWhiteSquare, clrWhiteSquare);
	REG_preserverDWORD(lpBlackPiece, clrBlackPiece);
	REG_preserverDWORD(lpWhitePiece, clrWhitePiece);
	REG_preserverDWORD(lpText, clrText);


	REG_fermerAcces();
}


/*------------------------------------------------------------------------
Procedure:     Color_getFromReg ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Color_getFromReg ( LPSTR appname )
{
	Color_setStandard ();

	if(!REG_ouvrirAcces(appname, NULL)) return;

	REG_recupererDWORD(lpBackGround, &clrBackGround);
	REG_recupererDWORD(lpBlackSquare, &clrBlackSquare);
	REG_recupererDWORD(lpWhiteSquare, &clrWhiteSquare);
	REG_recupererDWORD(lpBlackPiece, &clrBlackPiece);
	REG_recupererDWORD(lpWhitePiece, &clrWhitePiece);
	REG_recupererDWORD(lpText, &clrText);



	REG_fermerAcces();
}



