/*------------------------------------------------------------------------
Module:        C:\Maison\CodeC\Echec\frmExamine.c
Author:        Richard KIELBASA
Project:       Echecs
State:         termin
Creation Date: 18 12 2003
Description:   Consultation d'un fichier d'archive. See at the end of file
------------------------------------------------------------------------*/
#include <windows.h>
//#include <rkcontroles.h>
#include <richedit.h>
#include <stdio.h>
#include "couleurs.h"
//#include <debog.h>

#include "mainechecs.h"
#include "Echecs_rc.h"

/*variables prives-----------------------------------------------------*/
#define LGMAXLIGNE 384
/*procdures prives*/
static BOOL CALLBACK gererFrmExamine(HWND, UINT, WPARAM, LPARAM);
static BOOL terminerFrmExamine(HWND);
static BOOL chargerTexte(HWND, char*);

/*------------------------------------------------------------------------
Procedure:     appelExamine ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
int appelExamine(HWND hwndParent, FILE *nomFichier)
{
	/*
	* declaration des variables locales
	* =================================
	*/
	int irep;

	/*
	* code executable
	* ===============
	*/
	irep = DialogBoxParam(hInst, MAKEINTRESOURCE(DLG_EXAMINE), hwndParent, (DLGPROC) gererFrmExamine, (LPARAM)nomFichier);

	return irep;
}
/*------------------------------------------------------------------------
Procedure:     initFrmExamine ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static int initFrmExamine(HWND hwndDlg, WPARAM wParam, LPARAM lParam)
{
	/*
	* declaration des variables locales
	* =================================
	*/

	/*
	* code executable
	* ===============
	*/

	/*lire le contenu du fichier et afficher*/
	SetWindowText(hwndDlg, (char*)lParam);

	if(!chargerTexte( hwndDlg, (char*)lParam)) return -1;

	return 0;
}


/*------------------------------------------------------------------------
Procedure:     gererFrmExamine ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL CALLBACK gererFrmExamine(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	/*
	* declaration des variables locales
	* =================================
	*/
#define BORD 5

	/*
	* code executable
	* ===============
	*/
	switch (msg)
	{
	case WM_INITDIALOG:
		initFrmExamine(hwndDlg, wParam, lParam);
		return TRUE;

	case WM_SIZE:
		{
			RECT rect;

			GetClientRect(hwndDlg, &rect);
			MoveWindow(GetDlgItem(hwndDlg, TXT_EXAMINE),
				BORD, BORD, rect.right - (BORD + BORD), rect.bottom - (BORD + BORD),
				TRUE);
		}
		break;
	case WM_NOTIFY:
		break;
	case WM_COMMAND:
		switch( LOWORD(wParam))
		{
		case ITM_FERMEREXA:
			terminerFrmExamine(hwndDlg);
			break;
		case ITM_IMPEXA:
			MessageBox(hwndDlg, "Non disponible", "Echecs", MB_ICONINFORMATION);
			MessageBeep(MB_ICONINFORMATION);
			break;
		}
		break;
	case WM_CLOSE:
		terminerFrmExamine(hwndDlg);

		return TRUE;
	}
	return FALSE;
}
/*------------------------------------------------------------------------
Procedure:     terminerFrmExamine ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL terminerFrmExamine(HWND hwndDlg)
{
	/*
	* declaration des variables locales
	* =================================
	*/


	/*
	* code executable
	* ===============
	*/

	EndDialog(hwndDlg, 0);


	return TRUE;
}
/*------------------------------------------------------------------------
Procedure:     chargerTexte ID:1
Purpose:       Charge le contenu d'un fichier texte dans la zone d'dition
Input:         Nom du fichier contenant le texte
Output:
Errors:
------------------------------------------------------------------------*/
static BOOL chargerTexte(HWND hwndDlg, char *nomFichier)
{
	/*
	* declaration des variables locales
	* =================================
	*/
	HWND hwnd;
	char chaine [LGMAXLIGNE + 4];
	char *ptCar;
	FILE *fp;
	CHARFORMAT fmtcom, fmtdir;

	/*
	* code executable
	* ===============
	*/
	/*structure format (style commentaire )*/
	ZeroMemory(&fmtcom, sizeof(CHARFORMAT));

	fmtcom.cbSize = sizeof(CHARFORMAT);
	fmtcom.dwMask = CFM_COLOR|CFM_ITALIC;
	fmtcom.dwEffects = CFE_ITALIC;
	fmtcom.crTextColor = VERTFONCE;

	/*structure format (style directive)*/
	ZeroMemory(&fmtdir, sizeof(CHARFORMAT));

	fmtdir.cbSize = sizeof(CHARFORMAT);
	fmtdir.dwMask = CFM_COLOR;
	fmtdir.crTextColor = ROUGE;


	/*effacement de la zone*/
	hwnd = GetDlgItem(hwndDlg,  TXT_EXAMINE);
	SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM)"");

	/*ouverture du fichier*/
	fp = fopen(nomFichier, "r");
	if(fp == NULL)
	{
		MessageBox(hwndDlg, "Le fichier demand n'existe pas\n"
			    "S'il s'agit d'un fichier modifi, il n'a peut tre pas t gnr\n"
			    "Faites 'Gnrer->Ressources_ (F5)'", szAppName, MB_ICONEXCLAMATION);
		SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM)"<fichier vide>");
		return FALSE;
	}


	/*boucle de remplissage*/
	while(!feof(fp))
	{
		fgets(chaine, LGMAXLIGNE, fp);

		/*expliciter les retours  la ligne*/
		ptCar = strchr(chaine, '\n');
		if(ptCar == NULL)
			ptCar = chaine + LGMAXLIGNE - 1 ;

		*ptCar++ = '\r';
		*ptCar++ = '\n';
		*ptCar = '\0';

		/*curseur en fin de fichier*/
		SendMessage(hwnd, EM_SETSEL,  -1, -1);

		/*exprience*/
		if((*chaine == '/') && (*(chaine + 1) == '*'))
		{
			SendMessage(hwnd, EM_SETCHARFORMAT, (WPARAM)SCF_SELECTION, (LPARAM)&fmtcom);
		}
		else if(*chaine == '#')
		{
			SendMessage(hwnd, EM_SETCHARFORMAT, (WPARAM)SCF_SELECTION, (LPARAM)&fmtdir);
		}
		SendMessage(hwnd, EM_REPLACESEL, 0, (LPARAM)chaine);


	}

	fclose (fp);


	/*dslectionner le texte*/
	PostMessage(hwnd, EM_SETSEL,  0, 0);


	return TRUE;
}



