/*------------------------------------------------------------------------
 Module:        C:\Maison\CodeC\Echecs\frmstats.c
 Author:        Richard KIELBASA  (adaptateur)
 Project:       Echecs
 State:         Termin
 Creation Date: 7 12 2003
 Description:   See at the end of file

------------------------------------------------------------------------*/


#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>
#include "gnuchess.h"
#include "Echecs_rc.h"
#include "display.h"

/*donnes prives -------------------------------------------------------*/
static HWND hStats = NULL;
static LRESULT CALLBACK gererFrmStatistiques( HWND hDlg, unsigned message,WPARAM wParam, LPARAM lParam);

/*------------------------------------------------------------------------
Procedure:     appelStatistiques ID:1
Purpose:       Feuille non modale
Input:
Output:
Errors:
------------------------------------------------------------------------*/
HWND appelStatistiques (HWND hWnd, HANDLE hInst, RECT *rc)
{

	hStats = CreateDialogParam (hInst, MAKEINTRESOURCE(DLG_STATS), hWnd,(DLGPROC) gererFrmStatistiques, (LPARAM)rc);

	return hStats;
}

/*------------------------------------------------------------------------
Procedure:     Stats_destroy ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Stats_destroy(void)
{
	if(hStats)
		SendMessage ( hStats, WM_CLOSE, 0, 0 );
}


/*------------------------------------------------------------------------
Procedure:     gererFrmStatistiques ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static LRESULT CALLBACK gererFrmStatistiques ( HWND hDlg, unsigned message,WPARAM wParam, LPARAM lParam)
{

	switch (message)
	{
	case WM_INITDIALOG:		   /* message: initialize dialog box */
		{
			RECT rc;

			SetDlgItemText (hDlg, LBL_STAT_DEPTH,    " ");
			SetDlgItemText (hDlg, LBL_STAT_POSITION, " ");
			SetDlgItemText (hDlg, LBL_STAT_NODE,     " ");
			SetDlgItemText (hDlg, LBL_STAT_BSTLINE,  " ");
			SetDlgItemText (hDlg, LBL_STAT_SCORE,    " ");
			SetDlgItemText (hDlg, LBL_STAT_NODESEC,  " ");

			GetWindowRect(hDlg, &rc);
			rc.left = ((RECT*)lParam)->right - (rc.right - rc.left);
			rc.top  = ((RECT*)lParam)->bottom- (rc.bottom - rc.top);

			SetWindowPos(hDlg, NULL, rc.left , rc.top, 0,0, SWP_NOZORDER|SWP_NOSIZE	);
		}
		return (TRUE);

	case WM_CLOSE:
		DestroyWindow (hDlg);
		return TRUE;
		break;

	case WM_DESTROY:
		hStats = NULL;
		flag.post = false;
		break;
	}

	return (FALSE);			      /* Didn't process a message    */
}


/*------------------------------------------------------------------------
Procedure:     ShowDepth ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Stats_ShowDepth (char ch)
{
	char tmp[30];
	if ( hStats )
	{
		sprintf ( tmp, "%d%c", Sdepth, ch);
		SetDlgItemText ( hStats, LBL_STAT_DEPTH, tmp);
	}
}


/*------------------------------------------------------------------------
Procedure:     ShowScore ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void showScore (int score)
{
	char tmp[30];
	if ( hStats)
	{
		sprintf ( tmp, "%d",score);
		SetDlgItemText ( hStats, LBL_STAT_SCORE, tmp);
	}
}


/*------------------------------------------------------------------------
Procedure:     ShowCurrentMove ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Stats_ShowCurrentMove (int pnt, int f, int t)
{
	char tmp[30];

	if ( hStats)
	{
		makeMoveString (f, t, false);
		//sprintf ( tmp, "(%2d) %4s",pnt, (char *)mvstr[0]);
		sprintf ( tmp, "(%2d) %4s",pnt, (char *)Display_moveString);
		SetDlgItemText ( hStats, LBL_STAT_POSITION, tmp);
	}
}

/*------------------------------------------------------------------------
Procedure:     ShowNodeCnt ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Stats_ShowNodeCnt (long int NodeCnt, long int evrate)
{
	char tmp[40];

	if ( hStats )
	{
		sprintf ( tmp,"%-8ld", NodeCnt);
		SetDlgItemText ( hStats, LBL_STAT_NODE, tmp);
		sprintf ( tmp,"%-5ld", evrate);
		SetDlgItemText ( hStats, LBL_STAT_NODESEC, tmp);
	}
}



/*------------------------------------------------------------------------
Procedure:     ShowResults ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Stats_ShowResults (int score, unsigned int *bstline, char ch)
{
	unsigned char ply;//d
	char string[300];
	int nbcar;

	if (flag.post)
	{
		Stats_ShowDepth (ch);
		showScore (score);
		//d = 7;
		nbcar = 0;
		for (ply = 1; bstline[ply] > 0; ply++)
		{
			makeMoveString ((int) bstline[ply] >> 8, (int) bstline[ply] & 0xFF, false);
			if ( ply==5 || ply==9 || ply==13 || ply==17)
			{
				nbcar += sprintf ( string + nbcar,"\n");
			}
			//nbcar += sprintf ( string + nbcar,"%-5s ", (char *) mvstr[0]);
			nbcar += sprintf ( string + nbcar,"%-5s ", (char *) Display_moveString);
		}
		SetDlgItemText ( hStats, LBL_STAT_BSTLINE, (LPSTR) string);
	}
}
/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/
