/*------------------------------------------------------------------------
Module:        c:\maison\codec\echec\piece.c
Author:        Richard KIELBASA  (adaptateur)
Project:       Echecs
State:         Termin
Creation Date: 6 12 2003
Description:   See at the end of file
------------------------------------------------------------------------*/

#define NOATOM
#define NOCLIPBOARD
#define NOCREATESTRUCT
#define NOFONT
#define NOREGION
#define NOSOUND
#define NOWH
#define NOWINOFFSETS
#define NOCOMM
#define NOKANJI

#include <windows.h>
#include <stdio.h>

#include "mainechecs.h"
#include "gnuchess.h"
#include "board.h"
#include "clsimagelist.h"

/*procdures prives-----------------------------------------------------*/
static int convertCoordToIndex ( int x, int y);
static void drawOnePiece ( HDC hDC, int x, int y, int iPiece, DWORD color);

/*------------------------------------------------------------------------
Procedure:     Pieces_drawAll ID:1
Purpose: pbrd pointe sur un tableau de 64 cases reprsentant l'chiquier
pbrd+n est l'indice de case, *(pbrd+n) est l'indice de l'image de la piece
Input:
Output:
Errors:
------------------------------------------------------------------------*/
void Pieces_drawAll ( HDC hDC,  int reverse, int *pbrd, int *color,	DWORD clrblack, DWORD clrwhite )
{
	int i, j;
	int i0, j0;
	int n;

	for ( j = 0; j < 8; j++)
	{
		for (i = 0; i < 8; i++)
		{
			n = convertCoordToIndex (i, j);
			if ( *(color + n) != neutral )
			{
				if (reverse == 0)
				{
					i0 = i;
					j0 = j;
				}
				else
				{
					i0 = 7 - i;
					j0 = 7 - j;
				}
				drawOnePiece ( hDC, i0, j0, *(pbrd+n), (*(color+n) == black) ? clrblack : clrwhite );
			}
		}
	}
}


/*------------------------------------------------------------------------
Procedure:     convertCoordToIndex ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static int convertCoordToIndex ( int i, int j)
{
	return (j*8 + i );
}



/*------------------------------------------------------------------------
Procedure:     drawOnePiece ID:1
Purpose:
Input:
Output:
Errors:
------------------------------------------------------------------------*/
static void drawOnePiece ( HDC hDC, int i, int j, int iPiece, DWORD color)
{
	POINT point;
	POINT aptl[4];
	int size; /*hauteur de la case*/

	/*point*/
	/*
	0 : en bas  gauche
	1 : en bas  droite
	2 : en haut  droite
	3 :  en haut  gauche

	*/
	Board_querySqCoords ( i,  j, aptl );
	size = aptl[0].y - aptl[3].y;

	point.x = (aptl[1].x + aptl[0].x - size)/2 ;
	point.y = aptl[3].y;

	Images_showPiece ( hDC, &point, size,  iPiece, color);

}


/*
C source for GNU CHESS

Revision: 26 12 2003
Amlioration de l'interface MS WINDOWS par Richard Kielbasa

Revision: 1990-09-30

Modified by Daryl Baker for use in MS WINDOWS environment

Based on Ideas and code segments of Charles Petzold from artices in
MicroSoft Systems Journal.

This file is part of CHESS.

CHESS is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY.  No author or distributor accepts responsibility to anyone for
the consequences of using it or for whether it serves any particular
purpose or works at all, unless he says so in writing.  Refer to the CHESS
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute CHESS, but
only under the conditions described in the CHESS General Public License.
A copy of this license is supposed to have been given to you along with
CHESS so you can know your rights and responsibilities.  It should be in a
file named COPYING.  Among other things, the copyright notice and this
notice must be preserved on all copies.
*/
